<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    CorreosExpress/Departamento de integracion y desarrollo
 *  @copyright 2015-2016 Correos Express - Grupo Correos
 *  @license   LICENSE.txt
 *  @email peticiones@correosexpress.com
 */

include(dirname(__FILE__).'/../../config/config.inc.php');
include_once(_PS_ROOT_DIR_.'/init.php');
require_once('lib/tcpdf/tcpdf.php');
error_reporting(E_ERROR);
//Recogemos los valores por get
$date_f_ori = Tools::getValue('date_f');
$file_names_ori = Tools::getValue('file_names');
$type_ori   = Tools::getValue('pdfType');
$position_ori = Tools::getValue('position');
//Limpiamos y transformamos los valores de la metadata
$date_f = Tools::getIsset('date_f') ? $date_f_ori : 'NO_date';
$file_names = Tools::getIsset('file_names') ? $file_names_ori : 'NO_files';
$file_names = urldecode($file_names);
//$file_names = str_replace("#","+",$file_names);
$type = Tools::getIsset('pdfType') ? $type_ori : '1'; //1- 3etiqs adhesiva, 2- dina4 medio folio, 3 - termica
$position = Tools::getIsset('position') ? $position_ori : 1;

$per_page = 3;
$incH = 88;
$Output="";

// Instanciation of inherited class
if($type == '3') { //termica
  $pdf = new TCPDF('L','mm',array(150,100), true, 'UTF-8', false, false); //new PDF();
  $pdf->SetMargins(2, 2, 2);
} else {
  $pdf = new TCPDF('P', 'mm', 'A4', true, 'UTF-8', false, false); //('L','mm',array(210,115)); //new PDF();
  $pdf->SetAutoPageBreak(true, 0);
}

$pdf->SetPrintHeader(false);
$pdf->SetFooterMargin(0);
$pdf->SetPrintFooter(false);
$pdf->AddPage();

	$cb = $position - 1;//0; //counter barcodes in page
	$last_file = false;
	$files_arr = explode(',',$file_names);
	$arrlength=count($files_arr);
	if($type == '1') {
		$per_page = 3;
		$incH = 88;
	}
	else { //medio folio Y termica
		$per_page = 2;
		$incH = 130;
		if($type=='3') {
		    //$bc_gen_path_417 = str_replace("barcode_gen.php?text=", "barcode_gen_417.php?text=",$bc_gen_path);
		    $per_page = 1;
		}
	}
	//Pedidos del Listado
	for($j=0; $j<$arrlength;$j++) {
		$file = "barcodes/".$date_f."/".$files_arr[$j].".ini";
		$ini_array = parse_ini_file($file);
		if($ini_array['phone_receiver_local']=="")
			$phone_receiver_local = "";
		else 
			$phone_receiver_local =" / ".$ini_array['phone_receiver_local'];
		
		//Verificamos
		if(is_null($ini_array)){
			die("Error: No es posible acceder al fichero ".$files_arr[$j]);
		}
		
		//Bultos del pedido
		for($i=0; $i<$ini_array['bultos']; $i++)
		{
			$codsUnicos = explode('|',$ini_array['image']);
			$longitud_add_receiver = Tools::strlen($ini_array['address_receiver']);
					
			/**********************************************************************
			 *  Formato de la etiqueta tipo 1 Adhesivas - 3 por paginas
			 *
			 **********************************************************************/
			if($type == '1') { //adhesivas - 3 por pagina
			
				$pdf->SetFont('Helvetica','',9);
				$offset = 7;
				//set Y to start page o start new etiq (increment)
				$pdf->setY(9+($incH*$cb)+($offset*$cb));

				//print sender information
				$pdf->MultiCell(100,4, "Rte: ".$ini_array['name_sender']."\n".$ini_array['address_sender']."\n".$ini_array['postcode_sender']." ".$ini_array['city_sender']."\nContacto: ".$ini_array['phone_sender'].' '.$ini_array['contact_sender'],1,'L',0);

				//logo correos + codigo + retorno
				$pdf->Image("views/img/logo.png" ,150,10+($incH*$cb)+($offset*$cb),20,7,'PNG');
				$pdf->setXY(120, 16+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',14);

	        //get id ship
	        $idship = 0;
    		$sql = "SELECT * FROM "._DB_PREFIX_."savedships WHERE numcollect = '".$ini_array['num_order']."' ORDER BY id_ship DESC LIMIT 1";
    		if ($results = Db::getInstance()->ExecuteS($sql))
        		foreach ($results as $row) { $idship = $row["numship"]; }

				$pdf->Cell(80,8, "Env: ".$idship,0,1,'C');
				$pdf->setXY(120, 22+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',8);
				$pdf->Cell(80,3, "Envio retorno:",0,1,'C');

				//horizontal line
				$pdf->Line(110,25+($incH*$cb)+($offset*$cb),200,25+($incH*$cb)+($offset*$cb));

				$pdf->Cell(90,1,'',0,1,'L'); //blank
				$pdf->SetFont('Helvetica','',9); 	// Helvetica 10

				//ship information + barcode
				$pdf->Cell(90,4,'Env. Cli:',0,1,'L');
				$pdf->Cell(90,4,'Ref. Cli: '.$ini_array['num_order'],0,1,'L');

				$pdf->SetFont('Helvetica','B',12); 	// Helvetica bold 12

				$pdf->Cell(90,6,'Peso: '.$ini_array['kilos'].' kg',0,1,'L');
				$pdf->Cell(90,6,'Bulto: '.($i+1).' de '.$ini_array['bultos'], 0, 1, 'L');
				$pdf->Cell(90,2,'',0,1,'L'); //blank
				$pdf->SetFont('Helvetica','',10);
				if($ini_array['payback']) $pdf->Cell(90,5,'Reembolso: '.$ini_array['payback_val'],0,1,'L');
				if($ini_array['deliver_sat']) $pdf->Cell(90,5,'Entrega en sábado',0,1,'L');

        // define barcode style
        $style = array(
            'position' => '',
            'align' => 'C',
            'stretch' => true,
            'fitwidth' => false,
            'cellfitalign' => '',
            'border' => false,
            'hpadding' => 'auto',
            'vpadding' => 'auto',
            'fgcolor' => array(0,0,0),
            'bgcolor' => false, //array(255,255,255),
            'text' => false,
            'font' => 'Helvetica',
            'fontsize' => 8,
            'stretchtext' => 4
        );

        // barcode
        if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', 50,26+($incH*$cb)+($offset*$cb),98,26, 0.4, $style, 'N');
        else $pdf->write1DBarcode($codsUnicos[$i], 'C128', 50,26+($incH*$cb)+($offset*$cb),98,26, 0.4, $style, 'N');
        //barcode vertical
        $pdf->StartTransform();
        $pdf->Rotate(-90);
        
         // Se desplaza el código de barra vertical hacia la derecha
	     if($longitud_add_receiver <= '70'){   
	        //Codigo de barra vertical
	        if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', -06,-126+($incH*$cb)+($offset*$cb),32,24, 0.4, $style, 'N');
	        else                        $pdf->write1DBarcode($codsUnicos[$i], 'C128', -16,-126+($incH*$cb)+($offset*$cb),32,24, 0.4, $style, 'N');
	     }else{
	     	if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', -06,-134+($incH*$cb)+($offset*$cb),32,24, 0.4, $style, 'N');
	     	else                        $pdf->write1DBarcode($codsUnicos[$i], 'C128', -16,-134+($incH*$cb)+($offset*$cb),32,24, 0.4, $style, 'N');
	     }
        
        $pdf->StopTransform();
		//code of barcode under image
		$pdf->setXY(40, 52+($incH*$cb)+($offset*$cb));
		if(count($codsUnicos) == 1) $pdf->Cell(120,6, $codsUnicos[0],0,1,'C');
		else $pdf->Cell(120,6, $codsUnicos[$i],0,1,'C');

		//horizontal line
		$pdf->Line(10,60+($incH*$cb)+($offset*$cb),200,60+($incH*$cb)+($offset*$cb));

		//sender information
		$pdf->setY(61+($incH*$cb)+($offset*$cb));
		$pdf->MultiCell(140,4,$ini_array['name_receiver']."\nTfno: ".$ini_array['phone_receiver'].$phone_receiver_local."  Contacto: ".$ini_array['contact_receiver'],0,'L',0);
		
		// Dependiendo de la longitud
		if($longitud_add_receiver <= '70'){				
			$pdf->SetFont('Courier','B',12);
			$pdf->MultiCell(140,4,$ini_array['address_receiver'],0,'L',0);
			$pdf->SetFont('Courier','B',16);
			$pdf->Cell(140,6,$ini_array['postcode_receiver'].' '.$ini_array['city_receiver'],0,1,'L');
		}else{
			$pdf->SetFont('Courier','',12);
			if($longitud_add_receiver > '117') $ini_array['address_receiver'] = Tools::substr($ini_array['address_receiver'], 0, -3);
			$pdf->MultiCell(157,4,$ini_array['address_receiver'],0,'L',0);
			$pdf->SetFont('Courier','B',16);
			$pdf->Cell(140,6,$ini_array['postcode_receiver'].' '.$ini_array['city_receiver'],0,1,'L');
			
		}
				/** DM Country ***/
				$pdf->SetFont('Courier','B',12);

				//set iso image
				$pdf->Image("views/img/logo-iso.png" ,175,61+($incH*$cb)+($offset*$cb),20,20,'PNG');
				//set description references
				$pdf->SetFont('Helvetica','',10);
				$pdf->setXY(150, 61+($incH*$cb)+($offset*$cb));
				$pdf->Cell(30,6, $ini_array['desc_ref_1'],0,1,'L');
				$pdf->setXY(150, 81+($incH*$cb)+($offset*$cb));
				$pdf->Cell(30,6,$ini_array['desc_ref_2'],0,1,'L');

				//set footer information
				$pdf->SetFont('Helvetica','',8);
				$length_obs= Tools::strlen($ini_array['note_deliver']);
				if($length_obs<='71'){
					$pdf->Cell(120,8,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				}else{
					$pdf->SetFont('Helvetica','',7);
					$pdf->Cell(120,8,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				}
				
				//$pdf->Cell(120,8,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				$pdf->SetFont('Helvetica','B',12);
				$pdf->Cell(70,8,$ini_array['mode_ship_name'].' - '.$ini_array['country_delivery'],1,1,'L');				
				$pdf->SetFont('Helvetica','',8);
				$pdf->Cell(120,6,"El cliente acepta las condiciones del porte, y estar informado de la posibilidad de seguro a todo riesgo por el valor de la mercancia.",0,1,'L');
				//set lines
				//vertical
				$pdf->Line(200,9+($incH*$cb)+($offset*$cb),200,95+($incH*$cb)+($offset*$cb));
				if($longitud_add_receiver <= '70'){
					$pdf->Line(150,25+($incH*$cb)+($offset*$cb),150,87+($incH*$cb)+($offset*$cb));
				}else
					$pdf->Line(167,25+($incH*$cb)+($offset*$cb),167,87+($incH*$cb)+($offset*$cb));
				
				$pdf->Line(10,9+($incH*$cb)+($offset*$cb),10,95+($incH*$cb)+($offset*$cb));
				//horizontal
				$pdf->Line(10,9+($incH*$cb)+($offset*$cb),200,9+($incH*$cb)+($offset*$cb));
			} else if($type == '2') {
				//dina4 medio folio
				/*************************************************************
				 *  Formato de la etiqueta tipo 2 Medio Folio - 2 por paginas
				 *
				 ************************************************************/
				$pdf->SetFont('Helvetica','',10);

				$offset = 7;
				//set Y to start page o start new etiq (increment)
				$pdf->setY(9+($incH*$cb)+($offset*$cb));

				//print sender information
				$pdf->MultiCell(100,20,"Rte: ".$ini_array['name_sender']."\n".$ini_array['address_sender']."\n".$ini_array['postcode_sender']." ".$ini_array['city_sender']."\nContacto: ".$ini_array['phone_sender'].' '.$ini_array['contact_sender'],1,'L',0);

				//logo correos + codigo + retorno
				$pdf->Image("views/img/logo.png" ,150,10+($incH*$cb)+($offset*$cb),20,7,'PNG');
				$pdf->setXY(120, 16+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',16);
				
		        //get id ship
		        $idship = 0;
	    		$sql = "SELECT * FROM "._DB_PREFIX_."savedships WHERE numcollect = '".$ini_array['num_order']."' ORDER BY id_ship DESC LIMIT 1";
	    		if ($results = Db::getInstance()->ExecuteS($sql))
        		foreach ($results as $row) { $idship = $row["numship"]; }

				$pdf->Cell(80,10, "Env: ".$idship,0,1,'C');
				//$pdf->Cell(80,10, "Env: ".substr($codsUnicos[$i],0,-6),0,1,'C');
				$pdf->setXY(120, 24+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',8);
				$pdf->Cell(80,4, "Envio retorno:",0,1,'C');

				//horizontal line
				$pdf->Line(110,29+($incH*$cb)+($offset*$cb),200,29+($incH*$cb)+($offset*$cb));

				//$pdf->Cell(90,1,'',0,1,'L'); //blank
				$pdf->setXY(10, 32+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',9); 	// Helvetica 10

				//ship information + barcode
				$pdf->Cell(90,4,'Env. Cli:',0,1,'L');
				$pdf->Cell(90,4,'Ref. Cli: '.$ini_array['num_order'],0,1,'L');

				$pdf->SetFont('Helvetica','B',12); 	// Helvetica bold 12

				$pdf->Cell(90,6,'Peso: '.$ini_array['kilos'].' kg',0,1,'L');
				$pdf->Cell(90,6,'Bulto: '.($i+1).' de '.$ini_array['bultos'], 0, 1, 'L');
				$pdf->Cell(90,2,'',0,1,'L'); //blank
				$pdf->SetFont('Helvetica','',10);


		        // define barcode style
		        $style = array(
		            'position' => '',
		            'align' => 'C',
		            'stretch' => true,
		            'fitwidth' => false,
		            'cellfitalign' => '',
		            'border' => false,
		            'hpadding' => 'auto',
		            'vpadding' => 'auto',
		            'fgcolor' => array(0,0,0),
		            'bgcolor' => false, //array(255,255,255),
		            'text' => false,
		            'font' => 'Helvetica',
		            'fontsize' => 8,
		            'stretchtext' => 4
		        );
		
					  // barcode
		        if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', 50,33+($incH*$cb)+($offset*$cb),98,26, 0.4, $style, 'N');
		        else $pdf->write1DBarcode($codsUnicos[$i], 'C128', 50,33+($incH*$cb)+($offset*$cb),98,26, 0.4, $style, 'N');
		        //barcode vertical
		        $pdf->StartTransform();
		        $pdf->Rotate(-90);
		        if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', -15,-110+($incH*$cb)+($offset*$cb),30,0, 0.4, $style, 'N');
		        else $pdf->write1DBarcode($codsUnicos[$i], 'C128', -15,-110+($incH*$cb)+($offset*$cb),30,0, 0.4, $style, 'N');
		        $pdf->StopTransform();

				//code of barcode under image
				$pdf->setXY(40, 62+($incH*$cb)+($offset*$cb));
				if(count($codsUnicos) == 1) $pdf->Cell(120,6, $codsUnicos[0],0,1,'C');
				else $pdf->Cell(120,6, $codsUnicos[$i],0,1,'C');

				//horizontal line
				$pdf->Line(10,70+($incH*$cb)+($offset*$cb),200,70+($incH*$cb)+($offset*$cb));

				//sender information

				$pdf->setY(71+($incH*$cb)+($offset*$cb));
				$pdf->MultiCell(100,4,$ini_array['name_receiver']."\nTfno: ".$ini_array['phone_receiver'].$phone_receiver_local." Contacto: ".$ini_array['contact_receiver'],0,'L',0);
				$pdf->SetFont('Courier','B',12);
				$pdf->MultiCell(100,4,$ini_array['address_receiver'],0,'L',0);
				$pdf->SetFont('Courier','B',16);
				$pdf->Cell(100,10,$ini_array['postcode_receiver'].' '.$ini_array['city_receiver'],0,1,'L');
				$pdf->SetFont('Courier','B',12);

				//set iso image
				$pdf->Image("views/img/logo-iso.png" ,175,80+($incH*$cb)+($offset*$cb),20,20,'PNG');
				//set ship name and description references
				$pdf->SetFont('Helvetica','B',14);
				$pdf->setXY(110, 71+($incH*$cb)+($offset*$cb));
				$pdf->Cell(70,12,$ini_array['mode_ship_name'].' - '.$ini_array['country_delivery'],0,1,'L');
				$pdf->setXY(110, 82+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','B',10);
				if($ini_array['payback']) $pdf->Cell(90,5,'Reembolso: '.$ini_array['payback_val'],0,1,'L');	//contrareembolso
				$pdf->setXY(110, 88+($incH*$cb)+($offset*$cb));
				if($ini_array['deliver_sat']) $pdf->Cell(90,5,'Entrega en sábado',0,1,'L'); //saturday

				$pdf->SetFont('Helvetica','',8);
				$pdf->setXY(110, 96+($incH*$cb)+($offset*$cb));
				$pdf->Cell(30,6, $ini_array['desc_ref_1'],0,1,'L');
				$pdf->setXY(110, 102+($incH*$cb)+($offset*$cb));
				$pdf->Cell(30,6,$ini_array['desc_ref_2'],0,1,'L');

				//set footer information
				$pdf->setY(110+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',8);
				
				$length_obs= Tools::strlen($ini_array['note_deliver']);
				if($length_obs <='62'){
					$pdf->Cell(100,10,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				}else{
					$pdf->SetFont('Helvetica','',6.5);
					$pdf->Cell(100,10,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				}
				
				//$pdf->Cell(100,10,'Observaciones: '.$ini_array['note_deliver'],1,0,'L');
				$pdf->SetFont('Helvetica','',8);
				//*** DM ****
				//$pdf->MultiCell(45,10,"Fecha:".date("d-m-Y H:i:s")."\nConductor:",1,'L',0);
				$pdf->MultiCell(45,10,"Fecha: ".$ini_array['date_f']." "."\nConductor:",1,'L',0);
				$pdf->setXY(155, 110+($incH*$cb)+($offset*$cb));
				$pdf->MultiCell(45,10,"Firma y Fecha:\n ",1,'L',0);
				$pdf->SetFont('Helvetica','',8);
				$pdf->Cell(120,10,"El cliente acepta las condiciones del porte, y estar informado de la posibilidad de seguro a todo riesgo por el valor de la mercancia.",0,1,'L');
				$pdf->SetFont('Helvetica','',11);
                //$pdf->Cell(120,10,iconv("UTF-8", "ISO-8859-1","Copia "),0,1,'L');
				$pdf->Cell(120,10,"Copia PAQUETE RECOGIDAS 902 122 333            ATENCIÓN AL CLIENTE 902 111 021",0,1,'L');

				//set lines
				//vertical
				$pdf->Line(200,9+($incH*$cb)+($offset*$cb),200,122+($incH*$cb)+($offset*$cb));
				$pdf->Line(150,29+($incH*$cb)+($offset*$cb),150,70+($incH*$cb)+($offset*$cb));
				$pdf->Line(50,29+($incH*$cb)+($offset*$cb),50,70+($incH*$cb)+($offset*$cb));
				$pdf->Line(110,70+($incH*$cb)+($offset*$cb),110,110+($incH*$cb)+($offset*$cb));
				$pdf->Line(10,9+($incH*$cb)+($offset*$cb),10,122+($incH*$cb)+($offset*$cb));
				//horizontal
				$pdf->Line(10,9+($incH*$cb)+($offset*$cb),200,9+($incH*$cb)+($offset*$cb));
			} else {
				/*************************************************************
				 *  Formato de la etiqueta tipo 3 Termica - 1 por pág.
				 *
				 ************************************************************/
				//etiqueta termica
				$pdf->SetFont('Helvetica','',9);
				
				$offset = 27;
				//set Y to start page o start new etiq (increment)
				$pdf->setXY(2,2+($incH*$cb)+($offset*$cb));

				//print sender information
				$pdf->MultiCell(71,6,$ini_array['name_sender'].", ".$ini_array['contact_sender']."\n".$ini_array['address_sender']."\n".$ini_array['postcode_sender']." ".$ini_array['city_sender']."\t Telf: ".$ini_array['phone_sender'],1,'L',0);

				$pdf->setXY(75, 2+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',15);

	        //get id ship
	        $idship = 0;
    		$sql = "SELECT * FROM "._DB_PREFIX_."savedships WHERE numcollect = '".$ini_array['num_order']."' ORDER BY id_ship DESC LIMIT 1";
    		if ($results = Db::getInstance()->ExecuteS($sql))
        		foreach ($results as $row) { $idship = $row["numship"]; }
    		
    		//Obtener los Nombres de Productos
    		//$sql_product_name = "SELECT id_order,product_name FROM "._DB_PREFIX_."order_detail WHERE 1=1 and id_order= '".$ini_array['num_order']."'";
    		$sql_product_ref = "SELECT pr.reference,od.id_order,od.product_id FROM "._DB_PREFIX_."order_detail od INNER JOIN "._DB_PREFIX_."product pr ON(od.product_id=pr.id_product) WHERE id_order='".$ini_array['num_order']."'";
    		
    		$products_name = "";
    		if ($results_pname = Db::getInstance()->ExecuteS($sql_product_ref))
    			foreach ($results_pname as $row) { $products_name .= $row["reference"]." - "; }
    			
				$pdf->Cell(63,9, "EXP: ".$idship,0,1,'C');
				$pdf->setXY(70, 8+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','',8);
				$pdf->Cell(80,5, "Envio retorno:",0,1,'C');

				//horizontal line
				$pdf->Line(73,14+($incH*$cb)+($offset*$cb),147,14+($incH*$cb)+($offset*$cb));

				//sender information
				$pdf->setXY(4,14+($incH*$cb)+($offset*$cb));
				
				//Cambio de estilo dependiendo de la longitud de la dirección del destinatario
				//$longitud_add_receiver = strlen($ini_array['address_receiver']);
				//var_dump($longitud_add_receiver. "-- ".$ini_array['address_receiver']);
				if($longitud_add_receiver <= '70'){
					$pdf->SetFont('Courier','B',9);
					$pdf->Cell(71,3,$ini_array['name_receiver'],0,1,'L');
					$pdf->setX(4);
					$pdf->SetFont('Courier','',10);
					$pdf->Cell(71,3,$ini_array['contact_receiver'],0,1,'L');
	
					$pdf->SetFont('Helvetica','B',26);
					$pdf->setXY(4,21+($incH*$cb)+($offset*$cb));
					$pdf->Cell(71,6,$ini_array['postcode_receiver'],0,1,'L');
					$pdf->setXY(4,30+($incH*$cb)+($offset*$cb));
					$pdf->SetFont('Helvetica','B',11);
					$pdf->Cell(71,4,$ini_array['city_receiver'],0,1,'L');
					$pdf->setX(4);//,40+($incH*$cb)+($offset*$cb));
					$pdf->SetFont('Helvetica','',9);
					//$pdf->Cell(60,3,$ini_array['address_receiver'],0,1,'L');
	                $pdf->MultiCell(60,2,$ini_array['address_receiver'],0,'L',0);
					$pdf->setX(4);
					$pdf->SetFont('Courier','',8);
					//$pdf->MultiCell(70,2,"ATTN: ".$ini_array['contact_receiver']."\nTELF: ".$ini_array['phone_receiver'],0,'L',0);
	                $pdf->Cell(71,3,"\nTELF: ".$ini_array['phone_receiver'].$phone_receiver_local,0,1,'L');
	
					$pdf->setX(4);
					$pdf->SetFont('Helvetica','',8);
					//$pdf->Cell(71,2,'Observ: '.$ini_array['note_deliver'],0,1,'L');
					$pdf->MultiCell(71,2,'Observ: '.$ini_array['note_deliver'],0,'L',0);
					//$pdf->SetFont('Courier','B',12);
					
					//horizontal line
					$pdf->Line(2,53+($incH*$cb)+($offset*$cb),73,53+($incH*$cb)+($offset*$cb));
					//vertical line
					$pdf->Line(73,9+($incH*$cb)+($offset*$cb),73,53+($incH*$cb)+($offset*$cb));
					
				}else{
					$pdf->SetFont('Courier','B',9);
					$pdf->Cell(71,3,$ini_array['name_receiver'],0,1,'L');
					$pdf->setX(4);
					$pdf->SetFont('Courier','',10);
					$pdf->Cell(71,3,$ini_array['contact_receiver'],0,1,'L');
					
					$pdf->SetFont('Helvetica','B',26);
					$pdf->setXY(4,21+($incH*$cb)+($offset*$cb));
					$pdf->Cell(71,6,$ini_array['postcode_receiver'],0,1,'L');
					$pdf->setXY(4,30+($incH*$cb)+($offset*$cb));
					$pdf->SetFont('Helvetica','B',11);
					$pdf->Cell(71,4,$ini_array['city_receiver'],0,1,'L');
					$pdf->setX(4);//,40+($incH*$cb)+($offset*$cb));
					$pdf->SetFont('Helvetica','',8.5);
					//$pdf->Cell(60,3,$ini_array['address_receiver'],0,1,'L');
					//$pdf->MultiCell(60,2,$ini_array['address_receiver'],0,'L',0); -- DM
					$pdf->MultiCell(70,2,$ini_array['address_receiver'],0,'L',0);
					$pdf->setX(3);
					$pdf->SetFont('Courier','',7.5);
					//$pdf->MultiCell(70,2,"ATTN: ".$ini_array['contact_receiver']."\nTELF: ".$ini_array['phone_receiver'],0,'L',0);
					$pdf->Cell(71,3,"\nTELF: ".$ini_array['phone_receiver'].$phone_receiver_local,0,1,'L');
					
					$pdf->setX(4);
					$pdf->SetFont('Helvetica','B',6);
					//$pdf->Cell(71,2,'Observ: '.$ini_array['note_deliver'],0,1,'L');
					$pdf->MultiCell(71,2,'Observ: '.$ini_array['note_deliver'],0,'L',0);
					//$pdf->SetFont('Courier','B',12);
					
					//horizontal line(+10)
					$pdf->Line(2,55+($incH*$cb)+($offset*$cb),73,55+($incH*$cb)+($offset*$cb));
					//vertical line
					$pdf->Line(73,9+($incH*$cb)+($offset*$cb),73,55+($incH*$cb)+($offset*$cb));
					
				}
				
				//3 horizontal lines
				$pdf->Line(73,21+($incH*$cb)+($offset*$cb),147,21+($incH*$cb)+($offset*$cb));
				$pdf->Line(73,28+($incH*$cb)+($offset*$cb),147,28+($incH*$cb)+($offset*$cb));
				//$pdf->Line(73,38+($incH*$cb)+($offset*$cb),147,38+($incH*$cb)+($offset*$cb));
				//2 vertical lines
				$pdf->Line(98,14+($incH*$cb)+($offset*$cb),98,28+($incH*$cb)+($offset*$cb));
				$pdf->Line(120,14+($incH*$cb)+($offset*$cb),120,28+($incH*$cb)+($offset*$cb));

				$pdf->setXY(75, 14+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',8);
				//contrareembolso
				if($ini_array['payback']) {
					$pdf->Cell(23,3,"Reembolso:",0,1,'L');
					$pdf->SetFont('Courier','B',8);
					$pdf->SetX(75);
					$pdf->Cell(23,3,$ini_array['payback_val'],0,1,'L');
				}
				//bultos
				$pdf->setXY(101, 14+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',8);
				$pdf->Cell(23,3,'Bultos: ', 0, 1, 'L');
				$pdf->SetX(101);
				$pdf->SetFont('Courier','B',8);
				$pdf->Cell(23,3,($i+1).' de '.$ini_array['bultos'], 0, 1, 'L');
				//fecha
				$pdf->setXY(122, 14+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',8);
				$pdf->Cell(23,3,'Fecha: ', 0, 1, 'L');
				$pdf->SetX(122);
				$pdf->SetFont('Courier','B',8);
				// ------ DM -------
				//$pdf->Cell(23,3,date("d-m-Y"), 0, 1, 'L');
				$pdf->Cell(23,3,$ini_array['date_f'], 0, 1, 'L');
			
				//tipos portes
				$pdf->setXY(75, 21+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',8);
				$pdf->Cell(23,3,'Tipos portes: ', 0, 1, 'L');
				$pdf->SetX(75);
				$pdf->SetFont('Courier','B',8);
				$pdf->Cell(23,3,'Pagados', 0, 1, 'L');
				//peso
				$pdf->setXY(101, 21+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',8);
				$pdf->Cell(23,3,'Peso: ', 0, 1, 'L');
				$pdf->SetX(101);
				$pdf->SetFont('Courier','B',8);
				$pdf->Cell(23,3,$ini_array['kilos'].' kg', 0, 1, 'L');
				//saturday
				if($ini_array['deliver_sat']) {
					$pdf->setXY(122, 21+($incH*$cb)+($offset*$cb));
					$pdf->SetFont('Courier','',8);
					$pdf->MultiCell(20,3,'Entrega en sábado', 0, 'L', 0);
				}

				//ref + bulto cod
				//ship information + barcode
				$pdf->setXY(75, 28+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Courier','',10);
				$pdf->Cell(70,2,'REF: '.$ini_array['num_order'],0,1,'L');
				//code of barcode under image
				$pdf->SetXY(75, 31+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','B',9);
				if(count($codsUnicos) == 1) $pdf->Cell(70,6, "BULTO: ".$codsUnicos[0],0,1,'L');
				else $pdf->Cell(70,2, "BULTO: ".$codsUnicos[$i],0,1,'L');
				$pdf->SetX(75);//,31+($incH*$cb)+($offset*$cb));
				$pdf->Cell(70,2,'BUL. CLI:',0,1,'L');
				//mode ship name
				$pdf->setXY(75, 40+($incH*$cb)+($offset*$cb));
				$pdf->SetFont('Helvetica','B',14);
       			 $pdf->MultiCell(65,12,$ini_array['mode_ship_name'].' - '.$ini_array['country_delivery'],0,'L',0);

       			 //Nombre de Productos segun la orden
       			 $pdf->setXY(75, 46+($incH*$cb)+($offset*$cb));
       			 $pdf->SetFont('Courier','',5.5);
       			 //$pdf->Cell(3,5,'Prod.: '.$products_name, 0, 1, 'L');
       			 $pdf->MultiCell(68,5,"Producto/s: ".$products_name,0,'L',0);
       			 
				//create variable content pdf code (417) termic tag
				$content417 = date("d-m-Y")."\n"."codigo remitente?"."\n".$ini_array['name_sender']."\n".$ini_array['address_sender']."\n".$ini_array['postcode_sender']."\n".$ini_array['city_sender']."\n".$ini_array['phone_sender']."\n".$ini_array['name_receiver']."\n".$ini_array['address_receiver']."\n".$ini_array['postcode_receiver']."\n".$ini_array['city_receiver']."\n".$ini_array['phone_receiver']."\n".$ini_array['contact_receiver']."\n".$idship."\n"."codigo barras std?"."\n"."delegacion destino?"."\n".$ini_array['mode_ship_name']."\n".$ini_array['num_order']."\n".$ini_array['kilos']."\n".($i+1)."\n".$ini_array['bultos']."\n"."P"."\n".$ini_array['payback_val']."\n".$ini_array['note_collect']."\n".$ini_array['note_deliver'];

		        $style2 = array(
		            'border' => false,
		            'vpadding' => 0,
		            'hpadding' => 0,
		            'fgcolor' => array(0,0,0),
		            'bgcolor' => false, //array(255,255,255)
		            'module_width' => 1, // width of a single module in points
		            'module_height' => 1 // height of a single module in points
		        );
		
		        // barcode
		        $pdf->StartTransform();
		        $pdf->Rotate(-90);
				$pdf->Image("views/img/logo.png" ,10,-55+($incH*$cb)+($offset*$cb),20,8,'PNG');
		        $pdf->StopTransform();
		        
		        /***********************************************************************************
		         * barcode vertical , de momento se encuentra deshabilitado por la lógica del módulo 
		         * ya que no se puede hacer un grabado offline
		         ***********************************************************************************/
		        //$pdf->StartTransform();
		        //$pdf->Rotate(-90);
		        //if(count($codsUnicos) == 1) $pdf->write2DBarcode($content417, 'PDF417', -12,-90+($incH*$cb)+($offset*$cb),60,0, $style2, 'N', $false);
		        //else $pdf->write2DBarcode($content417, 'PDF417', -12,-90+($incH*$cb)+($offset*$cb),60,0, $style2, 'N', $false);
		        //$pdf->StopTransform();

		        // define barcode style
		        $style = array(
		            'position' => '',
		            'align' => 'L',
		            'stretch' => true,
		            'fitwidth' => false,
		            'cellfitalign' => '',
		            'border' => false,
		            'hpadding' => 0,
		            'vpadding' => 0,
		            'fgcolor' => array(0,0,0),
		            'bgcolor' => false, //array(255,255,255),
		            'text' => false,
		            'font' => 'Helvetica',
		            'fontsize' => 8,
		            'stretchtext' => 4
		        );
		        
		        //CODIGO DE BARRA ENVIO
		        $pdf->SetXY(5,59+($incH*$cb)+($offset*$cb));
		        if(count($codsUnicos) == 1) $pdf->write1DBarcode($codsUnicos[0], 'C128', '','',90,20, 0.4, $style, 'B');
		        else $pdf->write1DBarcode($codsUnicos[$i], 'C128', '','',90,20, 0.4, $style, 'B'); //+($incH*$cb)+($offset*$cb)
		
				$pdf->setXY(4, 70+($incH*$cb)+($offset*$cb));
		        $pdf->SetFont('Courier','B',14);		
		       
			}	
				$cb++;
				if ($cb == $per_page) {
					$pdf->AddPage();
					$cb = 0;
				}
				
		} //For end bultos del pedido
			
	}//For end listado de pedidos
	
	if($type=='3')
		$pdf->deletePage($pdf->getNumPages());
	
$Output = utf8_encode ($pdf->Output('etiquetas_'.$date_f.'.pdf', 'D'));
?>
