<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    CorreosExpress/Departamento de integracion y desarrollo	
 *  @copyright 2015-2016 Correos Express - Grupo Correos
 *  @license   LICENSE.txt
 *  @email peticiones@correosexpress.com
 */

	include(dirname(__FILE__)."/tools.php");  
	error_reporting(E_ERROR);
	
	if (!defined('_PS_VERSION_'))
		exit;

	class CorreosExpress extends Module
	{
		private $_html= '';
		private $AbsolutePath = '';
		private $logger;

		public function __construct()
		{
			$this->name = 'correosexpress';
			$this->tab = 'shipping_logistics';
			$this->version = '1.5.54';
			$this->author = 'Departamento de Integración';
			$this->need_instance = 0;
			$this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_); 
			//$this->bootstrap = true;
			//$this->display = 'view';
			parent::__construct();
			$this->displayName = $this->l('CorreosExpress - Gestión de envíos - Etiquetas');
			$this->description = $this->l('Gestión de envíos y sincronización con CorreosExpress. Control datapicker. Resumen total. Entrega en oficina BF. Seguimiento en historico de pedidos. Gestión tipo proceso de pedido.');
			$this->confirmUninstall = $this->l('¿Estas seguro que quieres desinstalar el módulo CorreosExpress?');

            if(!is_dir(dirname(__FILE__)."/log/")) 
            {
	    		$nd = mkdir(dirname(__FILE__)."/log", 0755, TRUE);
	    		if(!$nd)
	    		{
	    			die("nd es: ".$nd);
	    		}
			}
			
		}

		public function install()
		{
			CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

	 		if (Db::getInstance()->getValue('SELECT `id_module` FROM `'._DB_PREFIX_.'module` WHERE name =\''.pSQL($this->name).'\''))
            	return true;

			if (
				!parent::install() 
				//|| !$this->installDb()
				|| !$this->installDb2()
				|| !$this->installConfig()
				//|| !$this->autoConfigure() // solo para mis pruebas, usuario de Correos Express
				//|| !$this->installTab()
				|| !$this->registerHook('adminOrder') || !$this->registerHook ( 'extraCarrier' ) || !$this->registerHook ( 'orderDetailDisplayed' ) || !$this->registerHook ( 'paymentTop' )
			)
				return false;

            //Tools::deleteDirectory($this->cache_data, false);
            // if (!$this->installDb() || !$this->installTab() ||
            // 	!Configuration::updateGlobalValue('GF_INSTALL_CALC', 0) ||
            // 	!Configuration::updateGlobalValue('GF_CURRENT_LEVEL', 1) || !Configuration::updateGlobalValue('GF_CURRENT_LEVEL_PERCENT', 0) ||
            // 	!Configuration::updateGlobalValue('GF_NOTIFICATION', 0) || !parent::install() || !$this->registerHook('displayBackOfficeHeader'))
            // 	return false;
            
			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);

            return true;

		}

		public function uninstall()
        {

			CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

            if (
            	!$this->uninstallConfig()
            	|| !$this->uninstallDb2()
            	//|| !$this->uninstallTab()
            	|| !$this->unregisterHook('adminOrder') || !$this->unregisterHook('extraCarrier') || !$this->unregisterHook ( 'orderDetailDisplayed' ) || !$this->unregisterHook ( 'paymentTop' )
            	|| !parent::uninstall()
            )
                return false;
			
			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);
            
            return true;
        }

        public function installDb()
        {
                $return = true;
                include(dirname(__FILE__).'/sql_install.php');
                foreach ($sql as $s)
                        $return &= Db::getInstance()->execute($s);
                return $return;
        }

        public function installDb2()
        {
        	$sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."savedships`(
			`id_ship` INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`date` DATE NOT NULL, `numcollect` VARCHAR(255) NOT NULL,
			`numship` VARCHAR(20) NULL, `collectfrom` VARCHAR(50) NOT NULL,
			`postalcode` VARCHAR(10) NOT NULL,  `id_order` INT(11) NOT NULL,
			`id_mode` INT(11) NULL, `id_sender` INT(11) NULL,
			`type` ENUM('Recogida','Envio','Agrupado') NULL DEFAULT NULL,
			`kg` DECIMAL(7,2) NOT NULL, `package` INT(11) NOT NULL,
			`payback_val` DECIMAL(20,6) NULL DEFAULT NULL,`insured_value` DECIMAL(20,6) NULL DEFAULT NULL,
			`id_bc` INT(11) NOT NULL,
			`status` ENUM('Creado','Guardado','Grabado','Caducado') NOT NULL DEFAULT 'Creado',
			`id_ship_expired` INT(11) NULL DEFAULT NULL,
			`id_group` INT(11) NULL DEFAULT NULL)";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."savedsenders`(
			`id_sender` INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`name` VARCHAR(50) NOT NULL, `address` VARCHAR(90) NOT NULL,
			`postcode` VARCHAR(11) NOT NULL, `city` VARCHAR(20) NOT NULL,
			`contact` VARCHAR(30) NOT NULL, `phone` INT(14) NOT NULL, `from_hour` INT(2) NOT NULL,
			`from_minute` INT(2) NOT NULL, `to_hour` INT(2) NOT NULL,
			`to_minute` INT(2) NOT NULL )";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."savedmodeships`(
			`id_mode` INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`name` VARCHAR(50) NOT NULL, `id_bc` VARCHAR(5) NOT NULL)";
			if(!$result=Db::getInstance()->Execute($sql)) return false;
			
			$sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."officedeliverycorreo` (
			`id_officeDeliveryCorreo` INT(11) NOT NULL AUTO_INCREMENT,
			`id_cart` INT(11) NULL DEFAULT NULL,
			`id_carrier` INT(11) NULL DEFAULT NULL,
			`id_customer` INT(11) NULL DEFAULT NULL,
			`codigo_oficina` VARCHAR(300) NULL DEFAULT NULL,
			PRIMARY KEY (`id_officeDeliveryCorreo`))";
			if(!$result=Db::getInstance()->Execute($sql)) return false;
			
			/* INSERTS */
			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('PAQ 10', '61')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('PAQ 14', '62')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('PAQ 24', '63')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Baleares', '66')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Canarias Express', '67')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Canarias Aéreo', '68')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Canarias Marítimo', '69')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Internacional Express', '91')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Internacional Estandard', '90')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;
			
			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('Paq Empresa 14', '92')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;
			
			$sql = "INSERT INTO `"._DB_PREFIX_."savedmodeships` (`name`, `id_bc`) VALUES ('ePaq 24', '93')";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			// A partir de aqui, se ejecutan de base las modificaciones que contienen todos los upgrades del modulo a la base de datos

			$sql = "ALTER TABLE `"._DB_PREFIX_."savedmodeships` ADD `id_carrier` VARCHAR(255) NULL"; //add id_carrier
			if(!$result=Db::getInstance()->Execute($sql)) return false;			

			$sql = "ALTER TABLE `"._DB_PREFIX_."savedships` CHANGE COLUMN `numcollect` `numcollect` VARCHAR(255) NOT NULL"; 
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql =  'ALTER TABLE `'._DB_PREFIX_.'savedsenders` 
                    ADD UNIQUE INDEX `Senders_unicos_completos` (`name`, `address`, `postcode`, `city`, `contact`, `phone`, `from_hour`, `from_minute`, `to_hour`, `to_minute`)';
            try{ Db::getInstance()->Execute($sql); }
	        catch(PrestaShopDatabaseException $e){ if( Db::getInstance()->getNumberError()."" != "1060" && Db::getInstance()->getNumberError()."" != "1061" ) return false; }
	        catch(Exception $eg){ return false; }
			
			$sql =  "UPDATE "._DB_PREFIX_."savedships T1
                    INNER JOIN "._DB_PREFIX_."savedsenders T2 ON T1.collectfrom = T2.name
                    SET T1.id_sender = T2.id_sender
                    WHERE T1.collectfrom = T2.name";
            try{ Db::getInstance()->Execute($sql); }
	        catch(PrestaShopDatabaseException $e){ if( Db::getInstance()->getNumberError()."" != "1060" && Db::getInstance()->getNumberError()."" != "1061" ) return false; }
	        catch(Exception $eg){ return false; }

            $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships`
        			CHANGE COLUMN `type` `type` ENUM('Recogida','Envio','Recogida Agrupada','Envio Agrupado') NULL DEFAULT NULL";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
        			ADD UNIQUE INDEX `referencias_unicas` (`numcollect`,`type`)";
			if(!$result=Db::getInstance()->Execute($sql)) return false;

			$sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
        			ADD COLUMN `note_collect` LONGTEXT NULL";
        	if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `note_deliver` LONGTEXT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `iso_code` VARCHAR(10) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `devolution` ENUM('yes','no') NULL DEFAULT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `deliver_sat` ENUM('yes','no') NULL DEFAULT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `mailLabel` ENUM('yes','no') NULL DEFAULT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `desc_ref_1` VARCHAR(255) NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	        		ADD COLUMN `desc_ref_2` VARCHAR(255) NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedsenders` 
	        		ADD COLUMN `email` VARCHAR(255) NOT NULL";
	        try{ Db::getInstance()->Execute($sql); }
	        catch(PrestaShopDatabaseException $e){ if( Db::getInstance()->getNumberError()."" != "1060" && Db::getInstance()->getNumberError()."" != "1061" ) return false; }
	        catch(Exception $eg){ return false; }

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
     				CHANGE COLUMN `status` `status` ENUM('Creado','Guardado','Grabado','Agrupado','Caducado') NOT NULL DEFAULT 'Creado' AFTER `id_bc`";
        	if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `mode_ship_name` VARCHAR(50) NOT NULL AFTER `id_bc`";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `from_hour` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `from_minute` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `to_hour` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `to_minute` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `sender_name` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `sender_contact` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `sender_address` VARCHAR(120) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	    			ADD COLUMN `sender_postcode` VARCHAR(11) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `sender_city` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `sender_phone` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `sender_email` VARCHAR(255) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_name` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_contact` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_address` VARCHAR(120) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_postcode` VARCHAR(11) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_city` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_phone` VARCHAR(50) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

	        $sql =  "ALTER TABLE `"._DB_PREFIX_."savedships` 
	                ADD COLUMN `receiver_email` VARCHAR(255) NOT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;
	        
	        $sql = 	"ALTER TABLE `"._DB_PREFIX_."savedships`
	        		ADD COLUMN `oficina_entrega` TEXT NULL";
	        if(!$result=Db::getInstance()->Execute($sql)) return false;

			// Si todo va bien y no hemos salido antes por algun error, devolvemos true
			return true;
        }

        public function uninstallDb2()
        {
        	CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

        	if (!Db::getInstance()->Execute('DROP TABLE IF EXISTS '._DB_PREFIX_.'savedships'))
				return false;

			CEXTools::logToDisc("DROP TABLE IF EXISTS "._DB_PREFIX_."savedships",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("DROP TABLE IF EXISTS "._DB_PREFIX_."savedships", 1);
			/*
			if (!Db::getInstance()->Execute('DROP TABLE IF EXISTS '._DB_PREFIX_.'savedsenders'))
					return false;

			CEXTools::logToDisc("DROP TABLE IF EXISTS "._DB_PREFIX_.":savedsenders",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("DROP TABLE IF EXISTS "._DB_PREFIX_."savedsenders", 1);
			*/

			if (!Db::getInstance()->Execute('DROP TABLE IF EXISTS '._DB_PREFIX_.'savedmodeships'))
				return false;

			CEXTools::logToDisc("DROP TABLE IF EXISTS "._DB_PREFIX_."savedmodeships",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("DROP TABLE IF EXISTS "._DB_PREFIX_."savedmodeships", 1);
			
			if (!Db::getInstance()->Execute('DROP TABLE IF EXISTS '._DB_PREFIX_.'officedeliverycorreo'))
				return false;
			
			CEXTools::logToDisc("DROP TABLE IF EXISTS "._DB_PREFIX_."officedeliverycorreo",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("DROP TABLE IF EXISTS "._DB_PREFIX_."officedeliverycorreo", 1);
			
			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);
			
			return true;
        }

        public function installTab()
        {
			$idTabCreate = "";
			if(!$idTabCreate = $this->installModuleTab('AdminCorreosExpress', 'CorreosExpress', 0)) return false;
			if(!$this->installModuleTab('AdminCorreosExpress', 'Config', $idTabCreate)) return false;
			if(!$this->installModuleTab('AdminCorreosExpressPedidos', 'Pedidos', $idTabCreate)) return false;
			if(!$this->installModuleTab('AdminCorreosExpressEnvios', 'Envios', $idTabCreate)) return false;

			return true;
        }

        public function uninstallTab()
        {
        	CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

			if (
				!$this->uninstallModuleTab('AdminCorreosExpressPedidos')
				|| !$this->uninstallModuleTab('AdminCorreosExpressEnvios')
				|| !$this->uninstallModuleTab('AdminCorreosExpress')
				|| !$this->uninstallModuleTab('AdminCorreosExpress')
			) 
				return false; //Last remove parent

			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);

			return true;
        }

        public function installConfig()
        {
        	if(
				!Configuration::updateValue('MXPS_CODECUSTOMER', "")
			|| !Configuration::updateValue('MXPS_CODETAG', "")
			|| !Configuration::updateValue('MXPS_CODEDEMAND', "")
			|| !Configuration::updateValue('MXPS_USER', "")
			|| !Configuration::updateValue('MXPS_PASSWD', "")
			|| !Configuration::updateValue('MXPS_WSURL', "")
			|| !Configuration::updateValue('MXPS_WSURLREC', "")
			|| !Configuration::updateValue('MXPS_WSURLSEG', "")
			|| !Configuration::updateValue('MXPS_SELMODESHIP', "")
			|| !Configuration::updateValue('MXPS_DEFAULTPDF', "")
			|| !Configuration::updateValue('MXPS_DEFAULTKG', "")
			|| !Configuration::updateValue('MXPS_DEFAULTBUL', "")
			|| !Configuration::updateValue('MXPS_DEFAULTPAYBACK', "")
			|| !Configuration::updateValue('MXPS_ENABLESENDCRON', "")
			|| !Configuration::updateValue('MXPS_ENABLEDELIVERCRON', "")
			|| !Configuration::updateValue('MXPS_SENDCRONSTATE1', "")
			|| !Configuration::updateValue('MXPS_SENDCRONSTATE2', "")
			|| !Configuration::updateValue('MXPS_DELIVERCRONSTATE1', "")
			|| !Configuration::updateValue('MXPS_DELIVERCRONSTATE2', "")
			|| !Configuration::updateValue('MXPS_DEFAULTSEND', "")
        	|| !Configuration::updateValue('MXPS_ENABLEOFFICEDELIVERY', "")
        	|| !Configuration::updateValue('MXPS_MSG_DELIVERY_OFFICE', "<H4>Servicio Correos Express Entrega en Oficinas :</H4> seleccione la oficina en la cual desea recibir su envío.")
        	|| !Configuration::updateValue('MXPS_ENABLESHIPPINGTRACK', "")
        	|| !Configuration::updateValue('MXPS_ORDER_PROCESS_TYPE', "1")
        	|| !Configuration::updateValue('MXPS_CLASS_CONTRAREEMBOLSO', "a.cash")
        	|| !Configuration::updateValue('MXPS_MSG_ALERT_OFICINACORREOS', "Info. No está permitido utilizar el método contra reembolso para el servicio entrega en oficina de Correos.")		
        			
			// Minima configuracion necesaria
			|| !Configuration::updateValue('MXPS_WSURL', "https://www.correosexpress.com/wpsc/services/GrabacionEnvio?wsdl")
			|| !Configuration::updateValue('MXPS_WSURLREC', "https://www.correosexpress.com/wpsc/services/GrabacionRecogida?wsdl")
			|| !Configuration::updateValue('MXPS_WSURLSEG', "https://www.correosexpress.com/wpsc/services/SeguimientoEnvio?wsdl")
			|| !Configuration::updateValue('MXPS_SELMODESHIP', "")
			|| !Configuration::updateValue('MXPS_DEFAULTPDF', "")
			|| !Configuration::updateValue('MXPS_DEFAULTKG', "")
			|| !Configuration::updateValue('MXPS_DEFAULTBUL', "")
			|| !Configuration::updateValue('MXPS_DEFAULTPAYBACK', "cashondelivery")
        	|| !Configuration::updateValue('MXPS_APIRESTOFI', "https://www.correosexpress.com/wpsc/apiRestOficina/v1/oficinas/listadoOficinas")
      		|| !Configuration::updateValue('MXPS_CHECK_ENABLESHIPPINGTRACK', "")
       		|| !Configuration::updateValue('MXPS_VERSION_SCRIPT', "?version=153")
        	) 
				return false;
			
			return true;
        }

        public function autoConfigure()
        {
        	if(
			   !Configuration::updateValue('MXPS_CODECUSTOMER', "555550282")
			|| !Configuration::updateValue('MXPS_CODETAG', "1234")
			|| !Configuration::updateValue('MXPS_CODEDEMAND', "cd3160b29d58d3f28c6dab79e15f9fed")
			|| !Configuration::updateValue('MXPS_USER', "")
			|| !Configuration::updateValue('MXPS_PASSWD', "")
			|| !Configuration::updateValue('MXPS_WSURL', "https://www.correosexpress.com/wpsc/services/GrabacionEnvio?wsdl")
			|| !Configuration::updateValue('MXPS_WSURLREC', "https://www.correosexpress.com/wpsc/services/GrabacionRecogida?wsdl")
			|| !Configuration::updateValue('MXPS_WSURLSEG', "https://www.correosexpress.com/wpsc/services/SeguimientoEnvio?wsdl")
			|| !Configuration::updateValue('MXPS_SELMODESHIP', "")
			|| !Configuration::updateValue('MXPS_DEFAULTPDF', "1")
			|| !Configuration::updateValue('MXPS_DEFAULTKG', "1")
			|| !Configuration::updateValue('MXPS_DEFAULTBUL', "1")
			|| !Configuration::updateValue('MXPS_DEFAULTPAYBACK', "cashondelivery")
			|| !Configuration::updateValue('MXPS_ENABLESENDCRON', "")
			|| !Configuration::updateValue('MXPS_ENABLEDELIVERCRON', "")
			|| !Configuration::updateValue('MXPS_SENDCRONSTATE1', "")
			|| !Configuration::updateValue('MXPS_SENDCRONSTATE2', "")
			|| !Configuration::updateValue('MXPS_DELIVERCRONSTATE1', "")
			|| !Configuration::updateValue('MXPS_DELIVERCRONSTATE2', "")
			|| !Configuration::updateValue('MXPS_DEFAULTSEND', "")
			) 
				return false;
			
			return true;
        }

        public function uninstallConfig()
        {
        	CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

        	if(
				!Configuration::deleteByName('MXPS_CODECUSTOMER')
			|| !Configuration::deleteByName('MXPS_CODETAG')
			|| !Configuration::deleteByName('MXPS_CODEDEMAND')
			|| !Configuration::deleteByName('MXPS_USER')
			|| !Configuration::deleteByName('MXPS_PASSWD')
			|| !Configuration::deleteByName('MXPS_WSURL')
			|| !Configuration::deleteByName('MXPS_WSURLREC')
			|| !Configuration::deleteByName('MXPS_WSURLSEG')
			|| !Configuration::deleteByName('MXPS_SELMODESHIP')
			|| !Configuration::deleteByName('MXPS_DEFAULTPDF')
			|| !Configuration::deleteByName('MXPS_DEFAULTKG')
			|| !Configuration::deleteByName('MXPS_DEFAULTBUL')
			|| !Configuration::deleteByName('MXPS_DEFAULTPAYBACK')
			|| !Configuration::deleteByName('MXPS_ENABLESENDCRON')
			|| !Configuration::deleteByName('MXPS_ENABLEDELIVERCRON')
			|| !Configuration::deleteByName('MXPS_SENDCRONSTATE1')
			|| !Configuration::deleteByName('MXPS_SENDCRONSTATE2')
			|| !Configuration::deleteByName('MXPS_DELIVERCRONSTATE1')
			|| !Configuration::deleteByName('MXPS_DELIVERCRONSTATE2')
			|| !Configuration::deleteByName('MXPS_DEFAULTSEND')
        	|| !Configuration::deleteByName('MXPS_APIRESTOFI')
        	|| !Configuration::deleteByName('MXPS_ENABLEOFFICEDELIVERY')
        	|| !Configuration::deleteByName('MXPS_ENABLESHIPPINGTRACK')
        	|| !Configuration::deleteByName('MXPS_MSG_DELIVERY_OFFICE')
        	|| !Configuration::deleteByName('MXPS_ORDER_PROCESS_TYPE')
        	|| !Configuration::deleteByName('MXPS_CLASS_CONTRAREEMBOLSO')
        	|| !Configuration::deleteByName('MXPS_MSG_ALERT_OFICINACORREOS')
        	|| !Configuration::deleteByName('MXPS_CHECK_ENABLESHIPPINGTRACK')	
        	|| !Configuration::deleteByName('MXPS_VERSION_SCRIPT')
        			
        	) 
				return false;

			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);

			return true;
        }

		private function _generateForm() {

		$id_order = Tools::getValue('id_order');
		$order = new Order($id_order);
		$AbsolutePath = _PS_MODULE_DIR_.'correosexpress/';
		// Retrocompatibility (only for PS 1.4.4 or up)
		$this->initContext();

		//get idcarrier
		$sql = 'SELECT id_carrier FROM '._DB_PREFIX_.'orders WHERE id_order = '.$id_order;
		$idcarr = Db::getInstance()->getValue($sql);

		//get weight order
		$check_weigth_order = Configuration::get('MXPS_ENABLEWEIGHTORDER');
		if($check_weigth_order){
			$sql_weigth = 'SELECT weight FROM '._DB_PREFIX_.'order_carrier WHERE id_order = '.$id_order;
			$weigth = Db::getInstance()->getValue($sql_weigth);
		}else{
			$weigth = Configuration::get('MXPS_DEFAULTKG');
		}
		$weigth = round($weigth, 2, PHP_ROUND_HALF_ODD);
		
		
		if($this->isCarrierMapped($idcarr)) {

		$this->_html .= '<div class="col-lg-12">
		<div id="panel-cxps1" class="panel" style="padding:20px 20px 0; height:35px;">
		<div class="panel-heading">
		<i class="icon-truck"></i> Registro envío Correos Express
		<div class="panel-heading-action">
		<div class="btn-group">
		<a class="btn btn-default" onclick="tooglePanel(false, \'1\')">
		<i class="icon-minus"></i>
		</a>
		<a class="btn btn-default" onclick="tooglePanel(true, \'1\')">
		<i class="icon-plus"></i>
		</a>
		</div>
		</div>
		</div>
		<div id="content-cxps1" style="display:none;">
		<form id="shipform" action="'.$this->_path.'ajax.php" method="get">
		<div class="row">
		<div class="col-xs-4">';

		$data = $this->getSenderData(Configuration::get('MXPS_DEFAULTSEND'));	//get default sender data

		if(count($data)>0) $sender = $data[0];
		else $sender = array("name" => "", "contact" => "", "address"=>"", "postcode"=>"","city"=>"","phone"=>"","from_hour"=>"","from_minute"=>"","to_hour"=>"","to_minute"=>"");

		$this->_html .= '<div class="form-group">
		<h3>'.$this->l('Remitente').'</h3>
		<label><input type="checkbox" class="form_element" value="" id="loadSender" name="" onClick="enableElement(\'selFromCustomer\')"'; if(Configuration::get('MXPS_DEFAULTSEND') > 0) $this->_html .= ' checked>'; else $this->_html .= '>'; $this->_html .= $this->l('Copiar datos remitente').'</label>';

		$this->_html .= $this->getSenderSelect(Configuration::get('MXPS_DEFAULTSEND'));
		$this->_html .= '<p>'.$this->l('Nombre remitente').'</p><input type="text" class="form_element" value="'.$sender["name"].'" size="40" maxlength="40" id="name_sender" name=""><p>'.
		$this->l('Persona contacto').'</p><input type="text" class="form_element" value="'.$sender["contact"].'" size="40" id="contact_sender" name="" maxlength="40"><p>'.
		$this->l('Dirección recogida').'</p><input type="text" class="form_element" value="'.$sender["address"].'" size="45" id="address_sender" name="" maxlength="90"><p>'.
		$this->l('Código Postal').'</p><input type="text" class="form_element" value="'.$sender["postcode"].'" size="5" id="postcode_sender" name=""><p>'.
		$this->l('Población').'</p><input type="text" class="form_element" value="'.$sender["city"].'" size="40" id="city_sender" name=""><p>'.
		$this->l('Teléfono').'</p><input type="text" class="form_element" value="'.$sender["phone"].'" size="15" id="phone_sender" name="" pattern="\d+"><p>'.
		$this->l('Email').'</p><input type="email" class="form_element" value="'.Configuration::get('PS_SHOP_EMAIL').'" size="15" id="email_sender"  name=""><p>'.
		'<p><label><input type="checkbox" class="form_element" value="" id="enviarEtiquetaMail" name=""><b>'.$this->l('Enviar etiqueta por Email').'</b></label></p><p>'.
		$this->l('Observaciones recogida').'</p><textarea rows="4" cols="40" maxlength="79" name="" class="form_element" id="note_collect"></textarea>';
		$sql = 'SELECT payment FROM '._DB_PREFIX_.'orders WHERE id_order = '.$id_order;
		$payment = Db::getInstance()->getValue($sql); //get payment method name

		$sql = 'SELECT module FROM '._DB_PREFIX_.'orders WHERE id_order = '.$id_order;
		$module_payment = Db::getInstance()->getValue($sql); //get payment module name

		$sql = 'SELECT name FROM '._DB_PREFIX_.'carrier WHERE id_carrier = '.$idcarr;
		$name_carrier = Db::getInstance()->getValue($sql);

		$this->_html .= '<i>'.$this->l('Modo de pago: '). $payment.'<br/>'.
		$this->l('Modo de envío: '). $name_carrier.'</i>';

		$this->_html .=  '<hr/><label><input type="checkbox" class="form_element" value="" id="grabarRecogida" name=""><b>'.$this->l('Grabar recogida').'</b></label>
		</div>
		</div>
		<div class="col-xs-4">
		<div class="form-group">';

		$this->_html .=  '<h3>'.$this->l('Destinatario').'</h3>';
		$this->_html .= '<label><input type="checkbox" class="form_element" value="" id="loadReceiver" name="" onClick="enableElement(\'selToSender\')">'.$this->l('Es una devolución').'</label>';
		$this->_html .= $this->getReceiverSelect();

		//get dest customer adrress
		$id_order = Tools::getValue('id_order');
		$sql = 'SELECT id_address_delivery FROM '._DB_PREFIX_.'orders WHERE id_order = '.$id_order;
		$idad = Db::getInstance()->getValue($sql);
		$sql = 'SELECT * FROM '._DB_PREFIX_.'address WHERE id_address = '.$idad;
		if ($results = Db::getInstance()->ExecuteS($sql))
	
		//get customer to get email = destination email
		$id_customer=$order->id_customer;
		$customer= new Customer((int)$id_customer);

		$finalName = '';
		if ($results[0]['company'] != NULL || $results[0]['company'] != '') $finalName = $results[0]['company'];
		else $finalName = $results[0]['firstname'].' '.$results[0]['lastname'];
				
		$phone        = $results[0]['phone'];
		$phone_mobile = $results[0]['phone_mobile'];
		//duplicación del fijo si el movil no viene cargado
		if($phone_mobile =="" && $phone!="")
			$phone_mobile = $phone;
		
		//Message customer order
		$sql="SELECT ct.id_order,cm.message FROM "._DB_PREFIX_."customer_thread ct INNER JOIN "._DB_PREFIX_."customer_message cm 
				ON (ct.id_customer_thread = cm.id_customer_thread ) 
				WHERE ct.id_order = '".$id_order."' ";
		$message_customer='';
		if ($row_customer = Db::getInstance()->ExecuteS($sql))
			$message_customer = $row_customer[0]['message'];
		
		
		$this->_html .= '<p>'.$this->l('Nombre destinatario:').'</p><input type="text" class="form_element" value="'.$finalName.'" size="45" maxlength="45" id="name_receiver" name="" size="25"><p>'.
		$this->l('Persona de contacto').'</p><input type="text" class="form_element" value="'.$results[0]['firstname'].' '.$results[0]['lastname'].'" size="40" maxlength="40" id="contact_receiver" name=""><p>'.
		$this->l('Dirección:').'</p><input type="text" class="form_element" value="'.$results[0]['address1'].' '.$results[0]['address2'].'" maxlength="120" id="address_receiver" name=""><p>'.
		$this->l('Código postal').'</p><input type="text" class="form_element" value="'.$results[0]['postcode'].'" size="5" id="postcode_receiver" name=""><p>'.
		$this->l('Ciudad').'</p><input type="text" class="form_element" value="'.$results[0]['city'].'" size="40" id="city_receiver" name=""><p>'.
		$this->l('Telefono móvil / Fijo').'</p><div class="col-xs-6"><input type="text" class="form_element" value="'.$this->_getStringClean($phone_mobile).'" size="15" id="phone_receiver" pattern="\d+" name=""></div> <div class="col-xs-6"><input type="text" class="form_element" value="'.$this->_getStringClean($phone).'" size="15" id="telephone" pattern="\d+" name=""></div><p>'.
		$this->l('Email').'</p><input type="email" class="form_element" value="'.$customer->email.'" size="15" id="email_receiver"  name="">'.
		'<p><label>&nbsp;</label></p><p>'.

		$this->l('Observaciones entrega').'</p>
		<textarea rows="4" cols="40" maxlength="79" name="" class="form_element" id="note_deliver">'.$message_customer." ".$results[0]['other'].'</textarea>
		</div>
		</div>

		<div class="col-xs-4">
		<div class="form-group">';


		$this->_html .=  '<h3>'.$this->l('Envío').'</h3><p>'.

		$this->l('Código cliente de facturación').'</p>
		<select>
		<option>'.Configuration::get('MXPS_CODECUSTOMER').'</option>
		</select></br>';


		$this->_html .= '<input type="text" id="datepicker" name="date_picker"></br><p><div class="form_element_half">';

		$fh = $sender['from_hour'];
		$fm = $sender['from_minute'];
		$th = $sender['to_hour'];
		$tm = $sender['to_minute'];
		if(Tools::strlen($fh)==1) $fh = '0'.$fh;
		if(Tools::strlen($fm)==1) $fm = '0'.$fm;
		if(Tools::strlen($th)==1) $th = '0'.$th;
		if(Tools::strlen($tm)==1) $tm = '0'.$tm;

		$this->_html .= $this->l('Desde (hh)').'</p><input type="tel" pattern="[0-9]*" class="form_element_hour div_element_half" value="'.$fh.'" size="2" id="fromHH_sender" name=""></div><div class="form_element_half" style="margin-left:15px;"><p>
		'.$this->l('Desde (mm)').'</p><input type="tel" pattern="[0-9]*" class="form_element_hour div_element_half" value="'.$fm.'" size="2" id="fromMM_sender" name=""></div><p><div class="form_element_half">'
		.$this->l('Hasta (hh)').'</p><input type="tel" pattern="[0-9]*" class="form_element_hour div_element_half" value="'.$th.'" size="2" id="toHH_sender" name=""></div><div class="form_element_half" style="margin-left:15px;"><p>
		'.$this->l('Hasta (mm)').'</p><input type="tel" pattern="[0-9]*" class="form_element_hour div_element_half" value="'.$tm.'" size="2" id="toMM_sender" name=""></div><p>'.

		$this->l('Referencia de envío').'</p>
		<input type="text" class="form_element" value="'.$id_order.'" id="ref_ship" name="" maxlength="20" size="25">
		<input type="hidden" class="form_element" value="'.$id_order.'" id="ref_ship_old" name="ref_ship_old" maxlength="20" size="25"><p>'.

		$this->l('Descripción referencia(1)').'</p>
		<input type="text" class="form_element" value="" id="desc_ref_1" name="" maxlength="20" size="25"><p>'.

		$this->l('Descripción referencia(2)').'</p>
		<input type="text" class="form_element" value="" id="desc_ref_2" name="" maxlength="20" size="25"><p>'.

		$this->l('Modalidad de envío').'</p>';
		$this->_html .= $this->getCarrierSelect($idcarr);
		
		$entrega_oficina_front = $this->_getOfficeDataSelect($id_order);
		
		//var_dump($entrega_oficina_front,"<pre>");
		$envioOficina = $this->getEntregaOficinaCheck($idcarr);
		if($envioOficina){
			$this->_html .= '<span id="content_ent_ofi" ><p><label>'.$this->l('Entrega en oficina de Correos').'&nbsp;&nbsp;<input type="checkbox" class="" value="" id="entrega_oficina" name="entrega_oficina"></label></br><strong>*</strong>El servicio de entrega en oficinas no se puede realizar con importe de reembolso.';
			$this->_html .='
				<!-- Button trigger modal -->
				<div id="ocultar_form" class="ocultar_form">	
				<button type="button" class="btn btn-primary btn-md" data-toggle="modal" data-target="#myModal">
				  Buscador de oficinas
				</button>
			    </div>';
			
			//Si el envio tiene asignada la opción entrega en oficina 
			$sql_ent_ofi = 'SELECT numcollect,oficina_entrega FROM '._DB_PREFIX_.'savedships WHERE type=\'Envio\' AND status=\'Grabado\' AND (oficina_entrega IS NOT NULL) AND numcollect ='.$id_order;
			$row = Db::getInstance()->getRow($sql_ent_ofi);
            //var_dump($row);
            if ($row) {
            	$cod_oficina = array();
            	$cod_oficina = explode("#!#",$row['oficina_entrega']);
            	$cod_oficina_selecionada = $cod_oficina[0]; 
            	
            	$this->_html .=	"<script>
							$('#entrega_oficina').prop( \"checked\", true );
						    $('#ocultar_form').removeClass( \"ocultar_form\" ).addClass( \"mostrar_form\" );
						</script>";
            	
            	$this->_html .=	'<div id="cod_oficina_div"><span><strong>Código de Oficina:&nbsp;&nbsp;</strong>'.$cod_oficina_selecionada.'</span></div>';
            	
            	$this->_html .= '<div id="cod_oficina_div_entrega">
					<input id="codigo_oficina_entrega" name="codigo_oficina_entrega" type="hidden" value="'.$cod_oficina['0'].'" >
					<input id="dir_oficina" name="dir_oficina" type="hidden" value="'.$cod_oficina['1'].'" >
					<input id="nombre_oficina" name="nombre_oficina" type="hidden" value="'.$cod_oficina['2'].'" >
					<input id="codPostal_oficina" name="codPostal_oficina" type="hidden" value="'.$cod_oficina['3'].'" >
					<input id="pob_oficina" name="pob_oficina" type="hidden" value="'.$cod_oficina['4'].'" >
				</div>';
            
            }elseif(!$row && is_array($entrega_oficina_front)){
            	$data_oficina_front = explode("#!#",$entrega_oficina_front['codigo_oficina']);
				
				$data_oficina_front_codOfi      = $data_oficina_front[0];
				$data_oficina_front_dirOfi      = $data_oficina_front[1];
				$data_oficina_front_NombreOfi   = $data_oficina_front[2];
				$data_oficina_front_codigoPostal= $data_oficina_front[3];
				$data_oficina_front_poblacion   = $data_oficina_front[4];
				
				$this->_html .=	"<script>
							$('#entrega_oficina').prop( \"checked\", true );
						    $('#ocultar_form').removeClass( \"ocultar_form\" ).addClass( \"mostrar_form\" );							
						</script>";
				
            	$this->_html .=	'<div id="cod_oficina_div"><span><strong>Código de Oficina:&nbsp;&nbsp;</strong>'.$data_oficina_front_codOfi.'</span></div>';
            	
            	$this->_html .= '<div id="cod_oficina_div_entrega">
					<input id="codigo_oficina_entrega" name="codigo_oficina_entrega" type="hidden" value="'.$data_oficina_front_codOfi.'" >
					<input id="dir_oficina" name="dir_oficina" type="hidden" value="'.$data_oficina_front_dirOfi.'" >
					<input id="nombre_oficina" name="nombre_oficina" type="hidden" value="'.$data_oficina_front_NombreOfi.'" >
					<input id="codPostal_oficina" name="codPostal_oficina" type="hidden" value="'.$data_oficina_front_codigoPostal.'" >
					<input id="pob_oficina" name="pob_oficina" type="hidden" value="'.$data_oficina_front_poblacion.'" >
			
				</div>';
            	
            }else {
            	$this->_html .=	'<div id="cod_oficina_div"></div>';
            
				$this->_html .= '<div id="cod_oficina_div_entrega">
					<input id="codigo_oficina_entrega" name="codigo_oficina_entrega" type="hidden" >
					<input id="dir_oficina" name="dir_oficina" type="hidden" value"">
					<input id="nombre_oficina" name="nombre_oficina" type="hidden" >
					<input id="codPostal_oficina" name="codPostal_oficina" type="hidden" >
					<input id="pob_oficina" name="pob_oficina" type="hidden" >
					
				</div>';
            }
				$this->_html .= '<!-- Modal -->
				<div class="modal fade in" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
				  <div class="modal-dialog" role="document">
				    <div class="modal-content">
				      <div class="modal-header">
				        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				        <h4 class="modal-title" id="myModalLabel">Buscador</h4>
				      </div>
				      <div class="modal-body">
				       <span id="listOficce" name="listOficce">
							<div class="col-xs-6" >
								Código Postal:
								<input class="" type="text" value="" id="list_codigo_postal" name="list_codigo_postal"  size="3">
							</div>
										
							<div class="col-xs-6" >
							Población:
								<input class="" type="text" value="" id="list_poblacion" name="list_poblacion" size="3">
							</div>
							
					  </span>
						 <div id="listado_oficina_table"></div>	
					  </div>
				      <div class="modal-footer separar_superior">
				        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
				        <button id="buscar_ofi" type="button" class="btn btn-primary" name="buscar_ofi">Buscar oficinas</button>
				      </div>
				    </div>
				  </div>
				</div></p>
				</span><!-- span content_ent_ofi -->		
				';
		}else{
			$this->_html .= '<span id="content_ent_ofi" class="ocultar_form" ><p><label>'.$this->l('Entrega en oficina de Correos').'&nbsp;&nbsp;<input type="checkbox" class="" value="" id="entrega_oficina" name="entrega_oficina"></label></br><strong>*</strong>El servicio de entrega en oficinas no se puede realizar con importe de reembolso.';
			$this->_html .='
				<!-- Button trigger modal -->
				<div id="ocultar_form" class="ocultar_form">
				<button type="button" class="btn btn-primary btn-md" data-toggle="modal" data-target="#myModal">
				  Buscador de oficinas
				</button>
			    </div>';
			
			$this->_html .=	'<div id="cod_oficina_div"></div>';
			$this->_html .= '<div id="cod_oficina_div_entrega">
					<input id="codigo_oficina_entrega" name="codigo_oficina_entrega" type="hidden" >
					<input id="dir_oficina" name="dir_oficina" type="hidden" value"">
					<input id="nombre_oficina" name="nombre_oficina" type="hidden" >
					<input id="codPostal_oficina" name="codPostal_oficina" type="hidden" >
					<input id="pob_oficina" name="pob_oficina" type="hidden" >
			
				</div>
				<!-- Modal -->
				<div class="modal fade in" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
				  <div class="modal-dialog" role="document">
				    <div class="modal-content">
				      <div class="modal-header">
				        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				        <h4 class="modal-title" id="myModalLabel">Buscador</h4>
				      </div>
				      <div class="modal-body">
				       <span id="listOficce" name="listOficce">
							<div class="col-xs-6" >
								Código Postal:
								<input class="" type="text" value="" id="list_codigo_postal" name="list_codigo_postal"  size="3">
							</div>
			
							<div class="col-xs-6" >
							Población:
								<input class="" type="text" value="" id="list_poblacion" name="list_poblacion" size="3">
							</div>
				
					  </span>
						 <div id="listado_oficina_table"></div>
					  </div>
				      <div class="modal-footer separar_superior">
				        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
				        <button id="buscar_ofi" type="button" class="btn btn-primary" name="buscar_ofi">Buscar oficinas</button>
				      </div>
				    </div>
				  </div>
				</div></p>
				</span><!-- span content_ent_ofi -->
				';
		}
		
		$this->_html .= '<p>'.$this->l('País destino').'</p>';
		//get iso code from receiver address
		$sql = 'SELECT iso_code FROM '._DB_PREFIX_.'country WHERE id_country = '.$results[0]['id_country'];
		$iso_code = Db::getInstance()->getValue($sql);

		$this->_html .= $this->getISOCodes($this->context->employee->id_lang, $iso_code);
		
		$this->_html .= '<label><input type="checkbox" class="div_element_half" value="" id="deliver_sat" name="">'.$this->l('Entrega sábado').'</label>
		<label><input type="checkbox" class="div_element_half" value="" id="payback" name=""'; if(Configuration::get('MXPS_DEFAULTPAYBACK') == $module_payment) $this->_html .= ' checked/>'; else $this->_html .= ' />'; $this->_html .= $this->l('Contrareembolso').'</label></br><p>'.
		$this->l('Valor reembolso').'</p>
		<input type="number" class="form_element" value="'; if(Configuration::get('MXPS_DEFAULTPAYBACK') == $module_payment) $this->_html .= round($order->total_paid,2); $this->_html .= '" id="payback_val" name="" size="25" step="0.01"></br><div class="form_element_half">
		<input type="hidden" id="price_hide" value="'.round($order->total_paid,2).'">'.

		// Comentado porque no se usa en el XML
		'<p>'.$this->l('Valor Asegurado').'</p>
		<input type="number" class="form_element" value="" id="insured_value" name="" size="25" step="0.01"></br><div class="form_element_half">
		<input type="hidden" id="insured_value_hide" value=""><p>'.

		$this->l('Bultos').'</p>

		<input type="number" class="div_element_half" value="'.Configuration::get('MXPS_DEFAULTBUL').'" size="2" id="bultos" name="" size="25" min="1">
		<input type="checkbox" id="lastbultos"/>'.$this->l('Cargar último valor');

		//load ini last values file in barcodes folder
		$ini_file = parse_ini_file("barcodes/lastvalues.ini");
		$this->_html .= '<input type="hidden" id="lastbultos_hide" value="'.$ini_file['lastbultos'].'"/>
		</div><div style="margin-left:15px" class="form_element_half"><p>'.

		$this->l('Kilos').'</p>

		<input type="text" class="div_element_half" value="'.$weigth.'" size="2" maxlength="7" id="kilos" name="" >
		<input type="checkbox" id="lastkilos"/>'.$this->l('Cargar último valor').'
		<input type="hidden" id="lastkilos_hide" value="'.$ini_file['lastkilos'].'"/>
		</div>
		</div>
		</div>
		</div>
		<!-- Orders Actions -->
		<div class="well">
		<input type="hidden" id="id_order" value="'.$id_order.'"/>
		<input type="hidden" id="path" value="'.$this->_path.'"/>
		<input type="hidden" id="AbsPath" value="'.$AbsolutePath.'"/>
		<!--<input type="submit" value="'.$this->l('Grabar envío').'" class="btn btn-default"/>-->
		<button id="btnsubmitt" type="submit" class="btn btn-default">'.$this->l('Guardar envío').'</button>
		&nbsp;
		<span id="error-span" class="span label label-danger">
		<i class="icon-remove"></i>
		</span>&nbsp;
		<span id="success-span" class="span label label-success">
		<i class="icon-remove"></i>
		</span>
		</div>
		</div>
		</div>
		</form>
		
		</div>

		<div class="col-lg-6">
		<div id="panel-cxps2" class="panel" style="padding:20px 20px 0; height:35px;">
		<a name="historico"></a>
		<div class="panel-heading">
		<i class="icon-page"></i>		
		<i class="icon-file"></i> Histórico de envíos para este pedido
		<div class="panel-heading-action">
		<div class="btn-group">
		<a class="btn btn-default" onclick="tooglePanel(false, \'2\')">
		<i class="icon-minus"></i>
		</a>
		<a class="btn btn-default" onclick="tooglePanel(true, \'2\')">
		<i class="icon-plus"></i>
		</a>
		</div>
		</div>
		</div>
		<div id="content-cxps2" style="display:none;">
		<div class="row">'.
		$this->getSavedShipsTable().
		'</div>
		</div>
		</div></div>';
		
		/* POD para la impresión de Firmas de entrega
		$shippingNumber='6330008760998506';
		$zipCode='46960';
		$portlet='317698671';
		$url1='https://www.correosexpress.com/web/correosexpress/envios4?p_p_id=chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet&p_p_lifecycle=2&p_p_state=normal&p_p_mode=view&p_p_cacheability=cacheLevelPage&p_p_col_id=total&p_p_col_count=1&_chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet_struts.portlet.action=%2Fview%2Fview%2FgetPodImagen_execute&_chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet_struts.portlet.action=%2Fview%2FgetShippingPublic_execute&_chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet_pod='.$portlet.'+&_chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet_zipCode='.$zipCode.'&_chxseguimientoEnviosPublico_WAR_chxseguimientoEnviosPublicoportlet_shippingNumber='.$shippingNumber;
		$this->_html .= '<a target="_blank" href="'.$url1.'" >Click</a>';
		*/
		
		$date_picker= Tools::getValue('date_picker');
		//$date_f = date('d-m-Y');
		if($date_picker){
			$date_f= $date_picker;
		}else
			$date_f = date('d-m-Y');
		
			if(!is_dir($AbsolutePath.'barcodes/'. $date_f)) {
				$nd = mkdir($AbsolutePath.'barcodes/'. $date_f, 0755, TRUE);
			}
			
			$array_files = $this->directoryToArray($AbsolutePath."barcodes/".$date_f, false);
			$arrlength=count($array_files);
			$implode_file_names = "";
			$checklist = "";
						
			for($i=0; $i<$arrlength;$i++) {
				$implode_file_names .= basename($array_files[$i],".ini").",";
				$checklist .= '<span id="line_'.basename($array_files[$i],".ini").'"><input id="'.basename($array_files[$i],".ini").'" class="chk iniShip" type="checkbox" name="'.basename($array_files[$i],".ini").'" value="'.basename($array_files[$i],".ini").'" />';
				if(strrpos(basename($array_files[$i],".ini"),"|") !== false)
				{
					$checklist .= 'Referencias Envío Agrupado: '.basename($array_files[$i],".ini").'<span><br />';
				}
				else
				{
					$checklist .= 'Referencia envío: '.basename($array_files[$i],".ini").'</span><br />';
				}
			}

		//Cambio de funcionamiento ahora realiza la busqueda en la BD en vez de los .INI
		$array_files = $this->directoryToArray_BD($this->get_formatData_Ymd($date_f));
		
		$arrlength=count($array_files);
		$implode_file_names = "";
		
		$checklist = "";
		if($i > 0) $i = $i-1;
		foreach ($array_files as $clave => $valor){
			$checklist .= '<span id="line_'.$valor.'"><input id="'.$valor.'" class="chk iniShip" type="checkbox" name="'.$valor.'" value="'.$valor.'" />';
			if(strrpos(basename($array_files[$i],".ini"),"|") !== false)
			{
				$checklist .= 'Referencias Envío Agrupado: '.basename($array_files[$i],".ini").'<span><br />';
			}
			else
			{
				$checklist .= 'Referencia envío: '.$valor.'</span><br />';
			}
		}
		
		$this->_html .= '
		<div class="col-lg-6">
		<div id="panel-cxps3" class="panel" style="padding:20px 20px 0; height:35px;">
		<div class="panel-heading">
		<i class="icon-page"></i>
		<i class="icon-print"></i> Imprimir etiquetas / Grabaci&oacute;n
		<div class="panel-heading-action">
		<div class="btn-group">
		<form id="printresume" action="'.$this->_path.'ajax.php" method="get" style="display:inline-block; position:relative; top:2px;">
		<input type="hidden" id="list" value="'.$implode_file_names.'"/>
		<input type="hidden" id="path" value="'.$this->_path.'"/>
		<input type="submit" name="print_resume" value="'.$this->l('Imprimir resumen').'" class="btn btn-default"/>
		</form>
		<a class="btn btn-default" onclick="tooglePanel(false, \'3\')">
		<i class="icon-minus"></i>
		</a>
		<a class="btn btn-default" onclick="tooglePanel(true, \'3\')">
		<i class="icon-plus"></i>
		</a>
		</div>
		</div>
		</div>
		<div id="content-cxps3" style="display:none;">
		<div class="row">';
		$this->_html .= '<form id="printform" action="'.$this->_path.'ajax.php" method="get">

		<span id="error-span-2"></span>';
		$this->_html .= 'Dia: <span id="date_f">'.$date_f.'</span>';//.$AbsolutePath.'barcodes/'.$date_f;
		$this->_html .= '<div id="iniList" style=""><br />';

		$this->_html .= $checklist.'</div>
		<hr/>
		<label><input type="checkbox" class="form_element" value="" id="checkAll" name="">'.$this->l('Seleccionar todas las etiquetas del dia').'</label></br>
		<select id="selPdfType" class="selPdfType">
		<option value="1"'; if (Configuration::get('MXPS_DEFAULTPDF') == 1) $this->_html .= 'selected'; $this->_html .= '>Adhesivas</option>
		<option value="2"'; if (Configuration::get('MXPS_DEFAULTPDF') == 2) $this->_html .= 'selected'; $this->_html .= '>Medio folio</option>
		<option value="3"'; if (Configuration::get('MXPS_DEFAULTPDF') == 3) $this->_html .= 'selected'; $this->_html .= '>Térmica</option>
		</select></br>'.

		$this->l('Posición de primera etiqueta: ').'
		<input type="number" max="';
		if (Configuration::get('MXPS_DEFAULTPDF') == 1) $this->_html .= '3';
		if (Configuration::get('MXPS_DEFAULTPDF') == 2) $this->_html .= '1';
		if (Configuration::get('MXPS_DEFAULTPDF') == 3) $this->_html .= '1';
		$this->_html .= '" min="1" id="position_label" class="position_label" value="1"';
		if (Configuration::get('MXPS_DEFAULTPDF') == 3) $this->_html .= ' disabled';
		$this->_html .='/></br>

		<a href="#historico" id="previousDay">Día anterior</a> | <a href="#historico" id="nextDay">Día siguiente</a>
		<input type="hidden" id="path" value="'.$this->_path.'"/>
		<input type="hidden" id="AbsPath" value="'.$AbsolutePath.'"/>
		<input type="submit" name="print_codes" value="'.$this->l('Imprimir etiquetas/Grabar').'" class="button_form"/>
		</form>
		</div>
		</div>
		</div></div>';
		$version_script = ConfigurationCore::get("MXPS_VERSION_SCRIPT");
		//$this->_html .= '<script src="'.$this->_path.'js/script.js" type="text/javascript"></script>';
		$this->_html .= '<script src="'.$this->_path.'views/js/script.js'.$version_script.'" type="text/javascript"></script>';
		//$this->_html .= '<link rel="stylesheet" href="'.$this->_path.'css/style.css" type="text/css">';
		$this->_html .= '<link rel="stylesheet" href="'.$this->_path.'views/css/style.css'.$version_script.'" type="text/css">';

		} else { //carrier not mapped
			$this->_html .= '<div class="alert alert-warning" role="alert">'.$this->l('Esta orden tiene un trasportista asignado que no corresponde con niguna modalidad de envio de CorreosExpress').'</div>';
		}

		}

		public function getContent(){
			$html = '';
			if(Tools::isSubmit('submitModule')){
				if(Validate::isUrl(Tools::getValue('MXPS_CODECUSTOMER'))){
					Configuration::updateValue('MXPS_CODECUSTOMER',     Tools::getValue('MXPS_CODECUSTOMER'));
				} else {
					$html .= $this->displayError($this->l('Código de cliente inválido'));
				}				
				if(Validate::isUrl(Tools::getValue('MXPS_CODEDEMAND'))){
					Configuration::updateValue('MXPS_CODEDEMAND',     Tools::getValue('MXPS_CODEDEMAND'));
				} else {
					$html .= $this->displayError($this->l('Código de solicitante inválido'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_USER'))){
					Configuration::updateValue('MXPS_USER',     Tools::getValue('MXPS_USER'));
				} else {
					$html .= $this->displayError($this->l('Usuario inválido'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_PASSWD'))){
					Configuration::updateValue('MXPS_PASSWD',     Tools::getValue('MXPS_PASSWD'));
				} else {
					$html .= $this->displayError($this->l('Contraseña inválida'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_WSURL'))){
					Configuration::updateValue('MXPS_WSURL',     Tools::getValue('MXPS_WSURL'));
				} else {
					$html .= $this->displayError($this->l('Url del web service inválida (envio)'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_WSURLREC'))){
					Configuration::updateValue('MXPS_WSURLREC',     Tools::getValue('MXPS_WSURLREC'));
				} else {
					$html .= $this->displayError($this->l('Url del web service inválida (recogida)'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_WSURLSEG'))){
					Configuration::updateValue('MXPS_WSURLSEG',     Tools::getValue('MXPS_WSURLSEG'));
				} else {
					$html .= $this->displayError($this->l('Url del web service inválida (seguimiento)'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_SELMODESHIP'))){
					Configuration::updateValue('MXPS_SELMODESHIP',     Tools::getValue('MXPS_SELMODESHIP'));
				} else {
					$html .= $this->displayError($this->l('Debe seleccionar algún modo de envío.'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DEFAULTPDF'))){
					Configuration::updateValue('MXPS_DEFAULTPDF',     Tools::getValue('MXPS_DEFAULTPDF'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DEFAULTKG'))){
					Configuration::updateValue('MXPS_DEFAULTKG',     Tools::getValue('MXPS_DEFAULTKG'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ENABLEWEIGHTORDER'))){
					Configuration::updateValue('MXPS_ENABLEWEIGHTORDER',     Tools::getValue('MXPS_ENABLEWEIGHTORDER'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ENABLEOFFICEDELIVERY'))){
					Configuration::updateValue('MXPS_ENABLEOFFICEDELIVERY',     Tools::getValue('MXPS_ENABLEOFFICEDELIVERY'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_CLASS_CONTRAREEMBOLSO'))){
					Configuration::updateValue('MXPS_CLASS_CONTRAREEMBOLSO',     Tools::getValue('MXPS_CLASS_CONTRAREEMBOLSO'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_MSG_DELIVERY_OFFICE'))){
					Configuration::updateValue('MXPS_MSG_DELIVERY_OFFICE',     Tools::getValue('MXPS_MSG_DELIVERY_OFFICE'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_MSG_ALERT_OFICINACORREOS'))){
					Configuration::updateValue('MXPS_MSG_ALERT_OFICINACORREOS',     Tools::getValue('MXPS_MSG_ALERT_OFICINACORREOS'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ORDER_PROCESS_TYPE'))){
					Configuration::updateValue('MXPS_ORDER_PROCESS_TYPE',     Tools::getValue('MXPS_ORDER_PROCESS_TYPE'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ENABLESHIPPINGTRACK'))){
					Configuration::updateValue('MXPS_ENABLESHIPPINGTRACK',     Tools::getValue('MXPS_ENABLESHIPPINGTRACK'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_CHECK_ENABLESHIPPINGTRACK'))){
					Configuration::updateValue('MXPS_CHECK_ENABLESHIPPINGTRACK',     Tools::getValue('MXPS_CHECK_ENABLESHIPPINGTRACK'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DEFAULTBUL'))){
					Configuration::updateValue('MXPS_DEFAULTBUL',     Tools::getValue('MXPS_DEFAULTBUL'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DEFAULTSEND'))){
					Configuration::updateValue('MXPS_DEFAULTSEND',     Tools::getValue('MXPS_DEFAULTSEND'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DEFAULTPAYBACK'))){
					Configuration::updateValue('MXPS_DEFAULTPAYBACK',     Tools::getValue('MXPS_DEFAULTPAYBACK'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ENABLESENDCRON'))){
					Configuration::updateValue('MXPS_ENABLESENDCRON', Tools::getValue('MXPS_ENABLESENDCRON'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_ENABLEDELIVERCRON'))){
					Configuration::updateValue('MXPS_ENABLEDELIVERCRON', Tools::getValue('MXPS_ENABLEDELIVERCRON'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_SENDCRONSTATE1'))){
					Configuration::updateValue('MXPS_SENDCRONSTATE1', Tools::getValue('MXPS_SENDCRONSTATE1'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_SENDCRONSTATE2'))){
					Configuration::updateValue('MXPS_SENDCRONSTATE2', Tools::getValue('MXPS_SENDCRONSTATE2'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DELIVERCRONSTATE1'))){
					Configuration::updateValue('MXPS_DELIVERCRONSTATE1', Tools::getValue('MXPS_DELIVERCRONSTATE1'));
				}
				if(Validate::isUrl(Tools::getValue('MXPS_DELIVERCRONSTATE2'))){
					Configuration::updateValue('MXPS_DELIVERCRONSTATE2', Tools::getValue('MXPS_DELIVERCRONSTATE2'));
				}
				$html .= $this->displayConfirmation($this->l('Successfully saved configuration.'));
			}

			$MXPS_CODECUSTOMER    = Configuration::get('MXPS_CODECUSTOMER');
			//$MXPS_CODETAG    = Configuration::get('MXPS_CODETAG');
			$MXPS_CODEDEMAND    = Configuration::get('MXPS_CODEDEMAND');
			$MXPS_USER    = Configuration::get('MXPS_USER');
			$MXPS_PASSWD    = Configuration::get('MXPS_PASSWD');
			$MXPS_WSURL    = Configuration::get('MXPS_WSURL');
			$MXPS_WSURLREC    = Configuration::get('MXPS_WSURLREC');
			$MXPS_WSURLSEG    = Configuration::get('MXPS_WSURLSEG');
			$MXPS_SELMODESHIP    = Configuration::get('MXPS_SELMODESHIP');
			$MXPS_DEFAULTPDF    = Configuration::get('MXPS_DEFAULTPDF');
			$MXPS_DEFAULTKG    = Configuration::get('MXPS_DEFAULTKG');
			$MXPS_DEFAULTBUL    = Configuration::get('MXPS_DEFAULTBUL');
			$MXPS_DEFAULTSEND    = Configuration::get('MXPS_DEFAULTSEND');
			$MXPS_DEFAULTPAYBACK    = Configuration::get('MXPS_DEFAULTPAYBACK');
			//cron enviado
			$MXPS_ENABLESENDCRON    = Configuration::get('MXPS_ENABLESENDCRON');
			$MXPS_SENDCRONSTATE1    = Configuration::get('MXPS_SENDCRONSTATE1'); //estado para que cron actue
			$MXPS_SENDCRONSTATE2    = Configuration::get('MXPS_SENDCRONSTATE2'); //estado una vez cron ha actuado
			//cron entregado
			$MXPS_ENABLEDELIVERCRON    = Configuration::get('MXPS_ENABLEDELIVERCRON');
			$MXPS_DELIVERCRONSTATE1    = Configuration::get('MXPS_DELIVERCRONSTATE1'); //estado para que cron actue
			$MXPS_DELIVERCRONSTATE2    = Configuration::get('MXPS_DELIVERCRONSTATE2'); //estado una vez cron ha actuado
			$MXPS_ENABLEWEIGHTORDER    = Configuration::get('MXPS_ENABLEWEIGHTORDER'); //estado obtiene el peso del pedido
			$MXPS_ENABLEOFFICEDELIVERY    = Configuration::get('MXPS_ENABLEOFFICEDELIVERY'); //Activa la opción de entrega en oficina en Correos
			$MXPS_ENABLESHIPPINGTRACK    = Configuration::get('MXPS_ENABLESHIPPINGTRACK'); //Activa mensaje con enlace de seguimiento de correos express
			$MXPS_MSG_DELIVERY_OFFICE    = Configuration::get('MXPS_MSG_DELIVERY_OFFICE');
			$MXPS_MSG_ALERT_OFICINACORREOS      = Configuration::get('MXPS_MSG_ALERT_OFICINACORREOS');// alerta de metodo de envio entrega en oficina
			$MXPS_CLASS_CONTRAREEMBOLSO  = Configuration::get('MXPS_CLASS_CONTRAREEMBOLSO');
			$MXPS_ORDER_PROCESS_TYPE     = Configuration::get('MXPS_ORDER_PROCESS_TYPE');
			$MXPS_CHECK_ENABLESHIPPINGTRACK = Configuration::get('MXPS_CHECK_ENABLESHIPPINGTRACK');//activar el mensaje de alerta de entrega en oficina
			$MXPS_CHECK_VERSION_SCRIPT = Configuration::get('MXPS_VERSION_SCRIPT');//activar el mensaje de alerta de entrega en oficina
			
			$html .= '<script src="'.$this->_path.'views/js/script.js'.$MXPS_CHECK_VERSION_SCRIPT.'" type="text/javascript"></script>
			<link rel="stylesheet" href="'.$this->_path.'views/css/style.css" type="text/css">
			<div class="bootstrap">
					
			<form name="AdminCorreosExpress_frm" id="AdminCorreosExpress_frm" action="'.$_SERVER['REQUEST_URI'].'" method="post" class="defaultForm form-horizontal">
			<div class="panel" id="fieldset_0">
			<div class="panel-heading"><i class="icon-cogs"></i>'.$this->l('Configuración').'</div>
			<div class="form-wrapper">
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Código de cliente').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_CODECUSTOMER" id="MXPS_CODECUSTOMER" value="'.$MXPS_CODECUSTOMER.'" class="" type="text">
			</div>
			</div>
			
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Código de solicitante').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_CODEDEMAND" id="MXPS_CODEDEMAND" value="'.$MXPS_CODEDEMAND.'" class="" type="text">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Usuario').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_USER" id="MXPS_USER" value="'.$MXPS_USER.'" class="" type="text">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Contraseña').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_PASSWD" id="MXPS_PASSWD" value="'.$MXPS_PASSWD.'" class="" type="password">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('URL del web service (envío)').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_WSURL" id="MXPS_WSURL" value="'.$MXPS_WSURL.'" class="input-large" type="text">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('URL del web service (recogida)').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_WSURLREC" id="MXPS_WSURLREC" value="'.$MXPS_WSURLREC.'" class="input-large" type="text">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('URL del web service (seguimiento)').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_WSURLSEG" id="MXPS_WSURLSEG" value="'.$MXPS_WSURLSEG.'" class="input-large" type="text">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('KG por defecto').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_DEFAULTKG" id="MXPS_DEFAULTKG" value="'.$MXPS_DEFAULTKG.'" class="" type="text">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar PESO PEDIDO').'</label>
			<div class="col-lg-9 ">
			<input name="enable_weigth" id="enable_weigth" class="" type="checkbox" ';
			if($MXPS_ENABLEWEIGHTORDER == 1) $html .= 'checked';
			$html .= '>
			<input name="MXPS_ENABLEWEIGHTORDER" id="MXPS_ENABLEWEIGHTORDER" value="'.$MXPS_ENABLEWEIGHTORDER.'" class="" type="hidden">
			</div>
			</div>
					
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar enlace de seguimiento en el historial de compras del cliente').'</label>
			<div class="col-lg-9 ">
			<input name="enable_shippingtrack" id="enable_shippingtrack" class="" type="checkbox" ';
			if($MXPS_ENABLESHIPPINGTRACK == 1) $html .= 'checked';
			$html .= '>
			<input name="MXPS_ENABLESHIPPINGTRACK" id="MXPS_ENABLESHIPPINGTRACK" value="'.$MXPS_ENABLESHIPPINGTRACK.'" class="" type="hidden">
			</div>
			</div>		
					
								
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Bultos por defecto').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_DEFAULTBUL" id="MXPS_DEFAULTBUL" value="'.$MXPS_DEFAULTBUL.'" class="" type="number" min="1">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Tipo de etiqueta por defecto').'</label>
			<div class="col-lg-9 ">
			<select id="selPdfTypeDefault">
			<option value="1">Adhesiva</option>
			<option value="2">Medio folio</option>
			<option value="3">Térmica</option>
			</select>
			<input name="MXPS_DEFAULTPDF" id="MXPS_DEFAULTPDF" value="'.$MXPS_DEFAULTPDF.'" class="" type="hidden">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Remitente por defecto').'</label>
			<div class="col-lg-9 ">'.
			$this->getSenderSelectConfig(Configuration::get('MXPS_DEFAULTSEND')).'
			<input name="MXPS_DEFAULTSEND" id="MXPS_DEFAULTSEND" value="'.$MXPS_DEFAULTSEND.'" class="" type="hidden">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Método de pago contrareembolso').'</label>
			<div class="col-lg-9 ">
			<select id="selPaybackDefault">
				<option value="ninguno">Ninguno</option>';

			foreach (PaymentModule::getInstalledPaymentModules() as $payment){
				$module = Module::getInstanceByName($payment['name']);
				if (Validate::isLoadedObject($module) && $module->active)
					$html .= '<option value="'.$module->name.'">'.$module->displayName.'</option>';
			}

			$html .= '</select>
			<input name="MXPS_DEFAULTPAYBACK" id="MXPS_DEFAULTPAYBACK" value="'.$MXPS_DEFAULTPAYBACK.'" class="" type="hidden">
			</div>
			</div>
			
			<div class="form-group">		
				<div class="col-lg-3 "><h3>Configuración opciones activar CRON</h3></div>
				<div class="col-lg-6 "></div>
				<div class="col-lg-3 "></div>
			</div>	
					
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar cron ENVIADO').'</label>
			<div class="col-lg-9 ">
			<input name="enable_sendcron" id="enable_sendcron" class="" type="checkbox" ';

			if($MXPS_ENABLESENDCRON == 1) $html .= 'checked';
				$html .= '>
				<input name="MXPS_ENABLESENDCRON" id="MXPS_ENABLESENDCRON" value="'.$MXPS_ENABLESENDCRON.'" class="" type="hidden">
				</div>
				</div>

				<div class="form-group">
				<label class="control-label col-lg-3">'.$this->l('Estado para iniciar cron ENVIADO').'</label>
				<div class="col-lg-9 ">
				<select id="selSendCronS1">';

			$statuses = OrderState::getOrderStates((int)$this->context->language->id);

			foreach ($statuses as $os){
				if($MXPS_SENDCRONSTATE1 == $os['id_order_state'])
					$html .= '<option value="'.$os['id_order_state'].'" selected>'.$os['name'].'</option>';
				else
					$html .= '<option value="'.$os['id_order_state'].'">'.$os['name'].'</option>';
			}

			$html .= '</select>
			<input name="MXPS_SENDCRONSTATE1" id="MXPS_SENDCRONSTATE1" value="'.$MXPS_SENDCRONSTATE1.'" class="" type="hidden">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Estado resultante del cron ENVIADO').'</label>
			<div class="col-lg-9 ">
			<select id="selSendCronS2">';

			foreach ($statuses as $os){
				if($MXPS_SENDCRONSTATE2 == $os['id_order_state'])
					$html .= '<option value="'.$os['id_order_state'].'" selected>'.$os['name'].'</option>';
				else
					$html .= '<option value="'.$os['id_order_state'].'">'.$os['name'].'</option>';
			}

			$html .= '</select>
			<input name="MXPS_SENDCRONSTATE2" id="MXPS_SENDCRONSTATE2" value="'.$MXPS_SENDCRONSTATE2.'" class="" type="hidden">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar cron ENTREGADO').'</label>
			<div class="col-lg-9 ">
			<input name="enable_delivercron" id="enable_delivercron" class="" type="checkbox" ';
			if($MXPS_ENABLEDELIVERCRON == 1) $html .= 'checked';
			$html .= '>
			<input name="MXPS_ENABLEDELIVERCRON" id="MXPS_ENABLEDELIVERCRON" value="'.$MXPS_ENABLEDELIVERCRON.'" class="" type="hidden">
			</div>
			</div>
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Estado para iniciar cron ENTREGADO').'</label>
			<div class="col-lg-9 ">
			<select id="selDeliverCronS1">';

			foreach ($statuses as $os){
				if($MXPS_DELIVERCRONSTATE1 == $os['id_order_state'])
					$html .= '<option value="'.$os['id_order_state'].'" selected>'.$os['name'].'</option>';
				else
					$html .= '<option value="'.$os['id_order_state'].'">'.$os['name'].'</option>';
			}

			$html .= '</select>
			<input name="MXPS_DELIVERCRONSTATE1" id="MXPS_DELIVERCRONSTATE1" value="'.$MXPS_DELIVERCRONSTATE1.'" class="" type="hidden">
			</div>
			</div>

			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Estado resultante del cron ENTREGADO').'</label>
			<div class="col-lg-9 ">
			<select id="selDeliverCronS2">';

			foreach ($statuses as $os){
				if($MXPS_DELIVERCRONSTATE2 == $os['id_order_state'])
					$html .= '<option value="'.$os['id_order_state'].'" selected>'.$os['name'].'</option>';
				else
					$html .= '<option value="'.$os['id_order_state'].'">'.$os['name'].'</option>';
			}

			$html .= '</select>
			<input name="MXPS_DELIVERCRONSTATE2" id="MXPS_DELIVERCRONSTATE2" value="'.$MXPS_DELIVERCRONSTATE2.'" class="" type="hidden">
			</div>
			</div>

			<div class="form-group">		
				<div class="col-lg-3 "><h3>Configuración opciones de entrega en oficinas Correos (Paq 24, Baleares)</h3></div>
				<div class="col-lg-6 "></div>
				<div class="col-lg-3 "></div>
			</div>		
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar Entrega en Oficina de Correos FRONT').'</label>
			<div class="col-lg-9 ">
			<input name="enable_officeDelivery" id="enable_officeDelivery" class="" type="checkbox" ';
			if($MXPS_ENABLEOFFICEDELIVERY == 1) $html .= 'checked';
			$html .= '>
			<input name="MXPS_ENABLEOFFICEDELIVERY" id="MXPS_ENABLEOFFICEDELIVERY" value="'.$MXPS_ENABLEOFFICEDELIVERY.'" class="" type="hidden">
			</div>
			</div>
			
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Tipo de proceso de pedido(Entrega en oficina de correo)').'</label>
			<div class="col-lg-9 ">';
			
			$html .= 	$this->_getSelect_orderProcessType();
			
			$html .='<input name="MXPS_ORDER_PROCESS_TYPE" id="MXPS_ORDER_PROCESS_TYPE" value="'.$MXPS_ORDER_PROCESS_TYPE.'" class="" type="hidden">
			</div>
			</div>
					
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Mensaje servicio entrega en oficina(buscador de oficina).').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_MSG_DELIVERY_OFFICE" id="MXPS_MSG_DELIVERY_OFFICE" class="" type="text"  value="'.$MXPS_MSG_DELIVERY_OFFICE.'"  maxlength="200" size="200">
			</div>
			</div>	
			
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Activar mensaje de alerta servicio de entrega en oficina.').'</label>
			<div class="col-lg-9 ">
			<input name="check_enable_shippingtrack" id="check_enable_shippingtrack" class="" type="checkbox" ';
			if($MXPS_CHECK_ENABLESHIPPINGTRACK == 1) $html .= 'checked';
			$html .= '>
			<input name="MXPS_CHECK_ENABLESHIPPINGTRACK" id="MXPS_CHECK_ENABLESHIPPINGTRACK" value="'.$MXPS_CHECK_ENABLESHIPPINGTRACK.'" class="" type="hidden">
			</div>
			</div>				
					
			
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Mensaje de alerta servicio entrega en oficina(buscador de oficina).').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_MSG_ALERT_OFICINACORREOS" id="MXPS_MSG_ALERT_OFICINACORREOS" class="" type="text"  value="'.$MXPS_MSG_ALERT_OFICINACORREOS.'"  maxlength="200" size="200" >
			</div>
			</div>			
				
			<div class="form-group">
			<label class="control-label col-lg-3">'.$this->l('Selector control contra reembolso en el servicio entrega en oficinas(Oficinas de Correos)').'</label>
			<div class="col-lg-9 ">
			<input name="MXPS_CLASS_CONTRAREEMBOLSO" id="MXPS_CLASS_CONTRAREEMBOLSO" class="" type="text"  value="'.$MXPS_CLASS_CONTRAREEMBOLSO.'"  maxlength="50" size="50" >
			</div>
			</div>	
					

			<div class="form-group">
			<h3>'.$this->l('Selección métodos envío').'</h3>';

			$sql = 'SELECT * FROM '._DB_PREFIX_.'savedmodeships';
			if ($results = Db::getInstance()->ExecuteS($sql)){
				foreach ($results as $row) {
					$html .= '<label><input type="checkbox" class="form_element" value="'.$row['id_bc'].'" id="ms-'.$row['id_bc'].'" name="" onClick="selModeShip(\''.$row['name'].'\',\''.$row['id_bc'].'\')">'.$row['name'].'</label>';
				}
			}
			
			$protocolo_nav = '';
			//var_dump($_SERVER);
			if (isset($_SERVER['HTTPS']) && 'on' === $_SERVER['HTTPS']) {
				$protocolo_nav = "https://";
			} else {
				$protocolo_nav = "http://";
			}

			$html .= '<input name="MXPS_SELMODESHIP" id="MXPS_SELMODESHIP" value="'.$MXPS_SELMODESHIP.'" class="" type="hidden">

			<script>enableShipModeConfigChecks()</script>
			</div>
			<div class="form-group">

			</div><!-- /.form-wrapper -->

			<button type="submit" value="1" id="module_form_submit_btn" name="submitModule" class="btn btn-default pull-right">
			<i class="process-icon-save"></i> Guardar
			</button>

			</div>

			</form></div>
					
			
									
			<div class="bootstrap">

			<div class="panel" id="fieldset_0">
			<div class="panel-heading"><i class="icon-cogs"></i>'.$this->l('Añadir nuevos remitentes').'</div>
			<div class="form-wrapper">

			<div class="col-lg-6">
			<form id="sendersform" action="'.$this->_path.'ajax.php" method="get">
			<p>'.$this->l('Nombre remitente').'</p><input type="text" class="form_element" value="" size="40" maxlength="40" id="name_sender" name=""><p>'.

			$this->l('Persona contacto').'</p><input type="text" class="form_element" value="" size="40" id="contact_sender" name="" maxlength="40"><p>'.

			$this->l('Dirección recogida').'</p><input type="text" class="form_element" value="" size="45" id="address_sender" name="" maxlength="45"><p>'.

			$this->l('Código Postal').'</p><input type="text" class="form_element" value="" size="5" id="postcode_sender" name="postcode_sender"><p>'.

			$this->l('Población').'</p><input type="text" class="form_element" value="" size="40" id="city_sender" name=""><p>'.

			$this->l('Teléfono').'</p><input type="text" class="form_element" value="" size="15" id="phone_sender" name="" pattern="\d+"><p><div class="form_element_half">'.

			$this->l('Desde (hh)').'</p><input type="number" class="form_element_hour div_element_half" value="0" size="2" id="fromHH_sender" name=""></div><div class="form_element_half" style="margin-left:15px;"><p>

			'.$this->l('Desde (mm)').'</p><input type="number" class="form_element_hour div_element_half" value="0" size="2" id="fromMM_sender" name=""></div><p><div class="form_element_half">'

			.$this->l('Hasta (hh)').'</p><input type="number" class="form_element_hour div_element_half" value="0" size="2" id="toHH_sender" name=""></div><div class="form_element_half" style="margin-left:15px;"><p>

			'.$this->l('Hasta (mm)').'</p><input type="number" class="form_element_hour div_element_half" value="0" size="2" id="toMM_sender" name=""></div><p>

			<input type="submit" name="submit_sender" value="'.$this->l('Guardar').'" class="btn btn-default"/>
			&nbsp;
			<span id="error-span3" class="span label label-danger">
			<i class="icon-remove"></i>

			</span>&nbsp;
			<span id="success-span3" class="span label label-success">
			<i class="icon-check"></i>

			</span>&nbsp;

			<input type="hidden" id="path" value="'.$this->_path.'"/>
			<input type="hidden" id="idEditSender" value="-1"/>

			</form>
			</div>

			<div class="col-lg-6">
			';

			$html .= '<div class="table-responsive" style="overflow-x:scroll;">
			<table cellspacing="0" cellpadding="0" id="savedsenders" class="table">
			<thead><tr>
			<th align="center">&nbsp;</th>
			<th>'.$this->l('Nombre').'</th>
			<th>'.$this->l('Dirección').'</th>
			<th>'.$this->l('CP').'</th>
			<th>'.$this->l('Ciudad').'</th>
			<th>'.$this->l('Contacto').'</th>
			<th>'.$this->l('Telefono').'</th>
			<th>'.$this->l('Desde').'</th>
			<th>'.$this->l('Hasta').'</th>
			</tr>
			</thead><tbody>';

			$sql = 'SELECT * FROM '._DB_PREFIX_.'savedsenders ORDER BY id_sender DESC';
			if ($results = Db::getInstance()->ExecuteS($sql)){
				foreach ($results as $row) {
					$html .= '<tr><th>'.$row['id_sender'].'<button onclick="removeSender('.$row['id_sender'].')"><i class="icon-remove"></i></button><button onclick="loadSender('.$row['id_sender'].')"><i class="icon-pencil"></i></button></th><td>'.$row['name'].'</td><td>'.$row['address'].'</td><td>'.$row['postcode'].'</td><td>'.$row['city'].'</td><td>'.$row['contact'].'</td><td>'.$row['phone'].'</td>';
					$fh = $row['from_hour'];
					$fm = $row['from_minute'];
					$th = $row['to_hour'];
					$tm = $row['to_minute'];
					if(Tools::strlen($fh)==1) $fh = '0'.$fh;
					if(Tools::strlen($fm)==1) $fm = '0'.$fm;
					if(Tools::strlen($th)==1) $th = '0'.$th;
					if(Tools::strlen($tm)==1) $tm = '0'.$tm;
					$html .= '<td>'.$fh.':'.$fm.'</td><td>'.$th.':'.$tm.'</td></tr>';
				}
			}
			$html .= '</tbody></table></div>';

			$html .='</div></div></div>

			<div class="panel" id="fieldset_0">
			<div class="panel-heading"><i class="icon-cogs"></i>'.$this->l('Mapear modos de transporte con métodos de envío').'</div>
			<div class="form-wrapper">

			<div class="col-lg-6">
			<form id="carriersform" action="'.$this->_path.'ajax.php" method="get">';

			$id_shop = (int)$this->context->shop->id;

			$html .= $id_shop;

			$carriers = Carrier::getCarriers((int)$this->context->language->id);

			foreach ($carriers as $c){
				$html .= '<p>'.$c['name'].': '.$this->getCarrierSelectConfig($c['id_carrier']).'</p>';
			}

			$html .= '
			<input type="submit" name="submit_mapping" value="'.$this->l('Guardar').'" class="btn btn-default"/>
			<input type="hidden" id="langPS" value="'.$this->context->language->id.'"/>
			</form>
			</div></div></div>

			</div></div>';
			return $html;
		}

		public function directoryToArray($directory, $recursive) {
		$array_items = array();
		if ($handle = opendir($directory)) {
			while (false !== ($file = readdir($handle))) {
				if ($file != "." && $file != "..") {			
					if (is_dir($directory. "/" . $file)) {
						if($recursive) {
							$array_items = array_merge($array_items, directoryToArray($directory. "/" . $file, $recursive));
						}
						$file = $directory . "/" . $file;
						$array_items[filemtime($file)] = preg_replace("/\/\//si", "/", $file);
					} else {
						$file = $directory . "/" . $file;
						$array_items[filemtime($file)] = preg_replace("/\/\//si", "/", $file);
					}
				}
			}
		closedir($handle);
		}
		ksort($array_items);
		$list = array();

		foreach ($array_items as $f) $list[] = $f;
		return $list;
		}
		
		/**
		 * Obtiene las Referencias de los pedidos para un dia determinado
		 * @param Date $fecha_f
		 * @return array con las referencia encontradas para esa fecha
		 **/
		function directoryToArray_BD($fecha_f) {
			$list = array();
			$sql_list = "SELECT date,numcollect FROM "._DB_PREFIX_."savedships WHERE date='".$fecha_f."' GROUP BY  numcollect ASC";
			if ($results = Db::getInstance()->ExecuteS($sql_list)){
				foreach ($results as $row)
					$list[] = $row['numcollect'];
		
			}
			return $list;
		}
		
		/**
		 * Funci�n de Transformaci�n del formato Fecha de dd-mm-YYYY a YYYY-mm-dd
		 */
		function get_formatData_Ymd($date){
			if(Tools::isEmpty($date)){
				return false;
			}else{
				$date_array = explode("-", $date);
		
				if(is_array($date_array)){
					return $date_array['2']."-".$date_array['1']."-".$date_array['0'];
				}
				return date("d-m-Y");
			}
		}

		/**
		 * Envia un boolean dependiendo de si el carrier permite la entrega en oficina de Correo
		 * @param int $id_carrier
		 * @return boolean true despliega el check entregar en oficina de correos.
		 */
		function getEntregaOficinaCheck($id_carrier){
			
			if($id_carrier != ""){
			$sql_carr = "Select count(name) AS existe,id_bc,id_carrier FROM "._DB_PREFIX_."savedmodeships WHERE id_carrier LIKE '%".$id_carrier."%' AND (id_bc='63' || id_bc='66')";
			if ($results = Db::getInstance()->ExecuteS($sql_carr)){
				foreach ($results as $row)
					$carrier = $row['existe'];			
			}
			
			if($carrier)
				return true;
			else 
				return false;	
			}
			
			return false;			
		}
		

		/**
		 * Envia un array con la información de la oficina escogida por el usuario desde el front
		 *
		 * @param int id_orden
		 * @return array con la info
		 *
		 */
		private function _getOfficeDataSelect($id_order){
			//$sql_ent_ofi = "SELECT po.id_order,ofd.codigo_oficina FROM ps_orders po INNER JOIN ps_officedeliverycorreo ofd ON (po.id_cart = ofd.id_cart) WHERE po.id_order = '".$id_order."'";
			$sql_ent_ofi = "SELECT po.id_order,ofd.codigo_oficina FROM "._DB_PREFIX_."orders po INNER JOIN "._DB_PREFIX_."officedeliverycorreo ofd ON (po.id_cart = ofd.id_cart) WHERE po.id_order = '".$id_order."'";
			if($row_data_ofi = Db::getInstance()->getRow($sql_ent_ofi)){
				return $row_data_ofi;
			}else
				return false;
					
		}
		
		private function installModuleTab($tabClass, $tabName, $idTabParent){
			//@copy(_PS_MODULE_DIR_.strtolower($this->name).'/AdminModuleTesting.gif', _PS_IMG_DIR_.'t/'.$tabClass.'.gif');
			$tab = new Tab();
			//$tab->name = $tabName;
			$languages = Language::getLanguages();
			foreach ($languages AS $language){
			    $tab->{'name'}[intval($language['id_lang'])] = $tabName;
			}
			$tab->class_name = $tabClass;
			$tab->module = $this->name;
			$tab->id_parent = $idTabParent;
			$tab->active = 1;
			// if(!$tab->add()) print "failed";
			// else print "succeed";
			if(!$tab->save()) return false;

			return $tab->id;
		}

		private function uninstallModuleTab($tabClass){
			
			CEXTools::logToDisc("init",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("init", 1);

			$idTab = Tab::getIdFromClassName($tabClass);

			CEXTools::logToDisc("tabClass:".$tabClass." idTab:".$idTab,__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("tabClass:".$tabClass." idTab:".$idTab, 1);

			if($idTab != 0){
				$tab = new Tab($idTab);
				$tab->delete();
				//@unlink(_PS_IMG_DIR_.'t/'.$tabClass.'.gif');
				return true;
			}

			CEXTools::logToDisc("finish",__FILE__,__FUNCTION__,__LINE__,"all");
			PrestaShopLogger::addLog("finish", 1);

			return false;
		}

		public function hookadminOrder($params)
		{
			
			$this->_generateForm();
			return $this->_html;//.$this->fields_form;
		}
		
		public function hookDisplayOrderDetail($params)
		{
			$id_order = Tools::getValue('id_order');
			$sql_seguimiento = 'SELECT numship,postalcode,mode_ship_name,oficina_entrega FROM '._DB_PREFIX_.'savedships WHERE type=\'Envio\' AND status=\'Grabado\' AND numcollect ='.$id_order;
			$row = Db::getInstance()->getRow($sql_seguimiento);
			$enable_shippingtrack = Configuration::get('MXPS_ENABLESHIPPINGTRACK');
			$label_shipping_address = $this->l("Servicio de entrega en OFICINAS DE CORREOS");		
			$label_title_adrress = $this->l("Nombre/Dirección: ");
			$data_oficina_value = "";
			
			
			
			if($row && $enable_shippingtrack){
			$n_envio    = $row['numship'];
			$cod_postal = $row['postalcode'];
			$shipping_type_o_value = $row['mode_ship_name'];
			$data_oficina_value = $row['oficina_entrega'];
			$bandera = false;
			//si existen datos de entrega en oficina
			if(!is_null($data_oficina_value)){
				$data_oficina = explode("#!#", $data_oficina_value);
				$cod_postal = $data_oficina['3'];
				$bandera =true;
			}
			
			$this->context->smarty->assign(
					array(
							'label_shipping_tracking' => $this->l('Dirección de seguimiento:'),
							'label_shipping' => $this->l("URL : "),
							'tipo_envio' => $this->l("Tipo de Envío: "),
							'shipping_type_o_value' => $shipping_type_o_value,
							'url_shipping' => '<a href="https://www.chronoexpres.com/chronoExtraNET/env/verEnvio.seam?s='.$n_envio.'&cp='.$cod_postal.'" target="_blank" >'.$this->l("Enlace de seguimiento Correos Express").'</a>',
							'bandera' => $bandera,
							'label_shipping_address' => $label_shipping_address,
							'label_title_adrress' => $label_title_adrress,
							'data_oficina_value' => $data_oficina['2']."/ ".$data_oficina['1'].", ".$data_oficina['3']." ".$data_oficina['4'].".",
						)
					);
			
			return $this->display(__FILE__, 'displayOrderDetailSeguimientoHook.tpl');
			}
			return false;
		}
		
		public function hookDisplayCarrierList($params)
		{
			
			$AbsolutePath = _PS_MODULE_DIR_.'correosexpress/';
			$id_cart      = $this->context->cookie->id_cart;
			$id_carrier   = $this->context->cart->id_carrier;
			$id_customer  = $this->context->cart->id_customer;
			$carrierOfficeDeliveryCorreo = $this->getCarrierOfficeCorreos();
			$enable_officeDelivery = Configuration::get('MXPS_ENABLEOFFICEDELIVERY');
			$msg_delivery_office = $this->l(Configuration::get('MXPS_MSG_DELIVERY_OFFICE'));
			$order_process_type = ConfigurationCore::get("MXPS_ORDER_PROCESS_TYPE");
			$msg_alert_oficina_alert = ConfigurationCore::get("MXPS_MSG_ALERT_OFICINACORREOS");
			$class_contrareembolso = ConfigurationCore::get("MXPS_CLASS_CONTRAREEMBOLSO");
			$check_msg_alert = ConfigurationCore::get("MXPS_CHECK_ENABLESHIPPINGTRACK");
			$msg_confirm_oficina  = $this->l("El método de envío seleccionado permite la Entrega en Oficina de Correos.\n * Si desea este servicio haga clic en \"ACEPTAR\" y use el botón \"Buscador de Oficinas\".\n * Si desea la entrega en su dirección haga clic en \"CANCELAR\".");
			$msg_select_ofi_alert = $this->l("Info! Seleccione la oficina en la que desea recoger su paquete.");
			$msg_movil_sms         = $this->l("En su ficha deberá constar su número de móvil para recibir los avisos por SMS.\n \nSu compra será enviada a la oficina escogida.");
			$msg_otro_pago         = $this->l("Debe seleccionar otro método de pago.");
			$this->context->smarty->assign(
					array(
							'buscador' => $this->l('Buscador de Oficinas'),
							'title_buscador' => $this->l('Buscador'),
							'subtitle_buscador' => $this->l("Use el buscador por código postal o población para seleccionar la oficina deseada, haciendo clic en el botón verde."),
							'btn_cerrar' => $this->l('Cerrar'),
							'btn_buscar' => $this->l('Buscar Oficinas'),
							'label_codigo' => $this->l('Código Postal:'),
							'label_poblacion' => $this->l('Población:'),
							'label_poblacion' => $this->l('Población:'),
							'abs_path' => $this->_path,
							'id_cart' => $id_cart,
							'id_carrier' => $id_carrier,
							'id_customer' => $id_customer,
							'script_front' => $this->_path.'views/js/script_front_'.$order_process_type.'.js',
							'path_abs' => $this->_path.'views/css/',
							'carrierOfficeDeliveryCorreo' => $carrierOfficeDeliveryCorreo,
							'enable_officeDelivery' => $enable_officeDelivery,
							'msg_delivery_office' => $msg_delivery_office,
							'msg_alert_oficina_alert' => $msg_alert_oficina_alert,
							'class_contrareembolso' => $class_contrareembolso, 
							'check_msg_alert' => $check_msg_alert,
							'version_script' => ConfigurationCore::get("MXPS_VERSION_SCRIPT"),
							'msg_confirm_oficina' => $msg_confirm_oficina,
							'msg_select_ofi_alert' => $msg_select_ofi_alert,
							'msg_movil_sms' => $msg_movil_sms,
							'msg_otro_pago' => $msg_otro_pago,
							)
					);
			return $this->display(__FILE__, 'entregaOficinaHook.tpl');
		}
		
		public function hookDisplayPaymentTop($params){
			$check_alert_msg = ConfigurationCore::get("MXPS_CHECK_ENABLESHIPPINGTRACK");
			
			if($check_alert_msg == '1'){
			$tipo = ConfigurationCore::get("MXPS_ORDER_PROCESS_TYPE");
			if($tipo == '1'){
				$data_ofi="";
				$id_cart      = $this->context->cookie->id_cart;
				$sql = 'SELECT * FROM '._DB_PREFIX_.'officedeliverycorreo WHERE id_cart = '.$id_cart;
				if ($results = Db::getInstance()->ExecuteS($sql)){
					foreach ($results as $row) {
						$data_ofi .= $row['codigo_oficina'];
					}
				}
				if($data_ofi != ""){
					$path_js = $this->_path.'views/js/script_5pasos.js';
					$this->_html ='<script src="'.$path_js.'"></script>';
					$msg_alert_oficina_alert = ConfigurationCore::get("MXPS_MSG_ALERT_OFICINACORREOS");
					$this->_html .= '<div id="msg_alert_oficina" name="msg_alert_oficina" class="box_ofi alert alert-info" >'.$msg_alert_oficina_alert.'</div>';
					$msg_otro_pago = $this->l("Debe seleccionar otro método de pago.");
					$this->_html .= '<input id="msg_otro_pago" name="msg_otro_pago" type="hidden" value="'.$msg_otro_pago.'">';
					$class_contrareembolso = ConfigurationCore::get("MXPS_CLASS_CONTRAREEMBOLSO");
					$this->_html .= '<input id="class_contrareembolso" name="class_contrareembolso" type="hidden" value="'.$class_contrareembolso.'">';
					return $this->_html;//.$this->fields_form;
					
					
				}
			}
			}// If check_alert_msg
			
			return false;
		}
		
		public function getCarrierOfficeCorreos(){
			
			$service_active ="63,66";
			$sql = 'SELECT * FROM '._DB_PREFIX_.'savedmodeships WHERE id_bc IN ('.$service_active.')';
			
			if ($results = Db::getInstance()->ExecuteS($sql)){
				foreach ($results as $row) {
					$carriers .= $row['id_carrier'];
				}
			
			return $carriers;
			}
			
			return false;
		}
		
		/*************************** DATABASE ***************************************/
		public function getSenderSelect($id) {
		$ret = '';
		$ret .= '<select id="selFromCustomer" name="changeAddress"';
		if($id == 0) $ret .= ' disabled>';
		else $ret .= '>';

		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedsenders';
		if ($results = Db::getInstance()->ExecuteS($sql))
		foreach ($results as $row) {
		if($id == $row['id_sender'])
		$ret .= '<option value="'.$row['id_sender'].'" selected>'.$row['name'].'</option>';
		else $ret .= '<option value="'.$row['id_sender'].'">'.$row['name'].'</option>';
		}
		$ret .= '</select></br>';
		return $ret;
		}

		public function getSenderData($id) {
		//$ret = '';
		//$ret .= '<select id="selFromCustomer" name="changeAddress" disabled>';

		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedsenders WHERE id_sender = '.$id;
		$result = Db::getInstance()->ExecuteS($sql);
		/*foreach ($results as $row) {
		if($id == $row['id_sender'])
		$ret .= '<option value="'.$row['id_sender'].'" selected>'.$row['name'].'</option>';
		else $ret .= '<option value="'.$row['id_sender'].'">'.$row['name'].'</option>';
		}
		$ret .= '</select></br>';*/
		return $result;
		}

		public function getSenderSelectConfig($id) {
		$ret = '';
		$ret .= '<select id="selSenderDefault"><option value="0">Ninguno</option>';

		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedsenders';
		if ($results = Db::getInstance()->ExecuteS($sql))
		foreach ($results as $row) {
		if($id == $row['id_sender'])
		$ret .= '<option value="'.$row['id_sender'].'" selected>'.$row['name'].'</option>';
		else $ret .= '<option value="'.$row['id_sender'].'">'.$row['name'].'</option>';
		}
		$ret .= '</select>';
		return $ret;
		}

		public function getISOCodes($id_lang, $iso_code) {
		$ret = '<select id="selISOCode">';
		$sql = 'SELECT pscl.name, psc.iso_code FROM '._DB_PREFIX_.'country AS psc INNER JOIN '._DB_PREFIX_.'country_lang AS pscl ON psc.id_country = pscl.id_country WHERE pscl.id_lang = '.$id_lang;
		if ($results = Db::getInstance()->ExecuteS($sql))
		foreach ($results as $row) {
		if($iso_code == $row['iso_code']) {
		$ret .= '<option value="'.$row['iso_code'].'" selected>'.$row['name'].'</option>';
		} else $ret .= '<option value="'.$row['iso_code'].'">'.$row['name'].'</option>';
		}
		$ret .= '</select>';
		return $ret;
		}

		public function getReceiverSelect() {
		$ret = '';
		$ret .= '<select id="selToSender" name="changeAddress" disabled>';

		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedsenders';
		if ($results = Db::getInstance()->ExecuteS($sql))
		foreach ($results as $row) {
		$ret .= '<option value="'.$row['id_sender'].'">'.$row['name'].'</option>';
		}
		$ret .= '</select></br>';
		return $ret;
		}

		public function getCarrierSelect($idcarr) {
			$shipModesEnabled = Configuration::get('MXPS_SELMODESHIP');
			$sm_array = explode(",", $shipModesEnabled);

			$ret = '';
			$ret .= '<select id="selCarrier" name="">
			<option value="0">Escoge una modalidad</option>';

			$sql = 'SELECT * FROM '._DB_PREFIX_.'savedmodeships';
			if ($results = Db::getInstance()->ExecuteS($sql))
				foreach ($results as $row) {
					if (in_array($row['id_bc'], $sm_array)) {
						$arrCarriers = explode(',',$row['id_carrier']);
						if(in_array($idcarr, $arrCarriers)) {
							$ret .= '<option value="'.$row['id_bc'].'" selected>'.$row['name'].'</option>';
						} else {
							$ret .= '<option value="'.$row['id_bc'].'">'.$row['name'].'</option>';
						}
					}
				}
				$ret .= '</select></br>';
				return $ret;
		}

		//verify if order carrier has been mapped in configuration
		public function isCarrierMapped($idcarr) {
		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedmodeships';
		$ret = false;
		if ($results = Db::getInstance()->ExecuteS($sql))
		foreach ($results as $row) {
		$arrCarriers = explode(',',$row['id_carrier']);
		if(in_array($idcarr, $arrCarriers)) {
		//if($row['id_carrier'] == $idcarr) {
		$ret = true;
		}
		}
		return $ret;
		}

		public function getCarrierSelectConfig($idCarrier) {
			$shipModesEnabled = Configuration::get('MXPS_SELMODESHIP');
			$sm_array = explode(",", $shipModesEnabled);

			$ret = '';
			$ret .= '<select id="selCarrierConfig-'.$idCarrier.'" name="">
			<option value="0">sin asignar</option>';

			$sql = 'SELECT * FROM '._DB_PREFIX_.'savedmodeships';
			if ($results = Db::getInstance()->ExecuteS($sql))
				foreach ($results as $row) {
					if (in_array($row['id_bc'], $sm_array)) {
						$arrCarriers = explode(',',$row['id_carrier']);
						if(in_array($idCarrier,$arrCarriers))	{
							//if($row['id_carrier'] == $idCarrier) {
							$ret .= '<option value="'.$row['id_bc'].'" selected>'.$row['name'].'</option>';
						} else {
							$ret .= '<option value="'.$row['id_bc'].'">'.$row['name'].'</option>';
						}

					}
				}
				$ret .= '</select></br>';
				return $ret;
		}

		public function getSavedShipsTable() {
			$id_order = Tools::getValue('id_order');
			$ret = '';
			$ret .= '<table cellspacing="0" cellpadding="0" id="savedShips" class="table" style="width: 868px;">
			<thead><tr>
			<th align="center" style="width: 60px">&nbsp;</th>
			<th>'.$this->l('Fecha').'</th>
			<th>'.$this->l('Ref envío').'</th>
			<th>'.$this->l('Nº Envío').'</th>
			<th>'.$this->l('Recogida desde...').'</th></tr>
			</thead><tbody>';
			$sql = "SELECT id_order,numship,postalcode,date,numcollect,collectfrom,oficina_entrega FROM "._DB_PREFIX_."savedships WHERE id_order = ".$id_order." AND status = 'Grabado' ORDER BY id_ship DESC LIMIT 5";
			if ($results = Db::getInstance()->ExecuteS($sql))
			{
				foreach ($results as $row) {
					if($id_order == $row['id_order'])
					{
						if($row['oficina_entrega'] != ""){
							$codP = explode("#!#", $row['oficina_entrega']); 
							$cod_postal =$codP['3']; 
						}else{
							$cod_postal = $row['postalcode'];
						}
						
						$ret .= '<tr style="font-size:12px; color:#333"><th>';
						if(mb_strtoupper("".$row['numship']) != "AUTOMATICA") 
							$ret .= '<a href="https://www.chronoexpres.com/chronoExtraNET/env/verEnvio.seam?s='.$row['numship'].'&cp='.$cod_postal.'" target="_blank">';
						$ret .= 'CorreosExpress';
						if(mb_strtoupper("".$row['numship']) != "AUTOMATICA") 
							$ret .= '</a>';
						$ret .= '</th><th>'.date("d-m-Y", strtotime($row['date'])).'</th><th>'.$row['numcollect'].'</th><th>'.$row['numship'].'</th><th>'.$row['collectfrom'].'</th></tr>';
						$ret .= "<tr style=\"display:none;\"><td>".mb_strtoupper("".$row['numship'])."</td></tr>";
					}
				}
			}
			$ret .= '</tbody></table>';

			//._PS_MODULE_DIR_.' ::: '._PATH.' ::: '.$this->_path;
			return $ret;
		}

		/**
		 * Función auxiliar que permite eliminar espacios en blanco al inicio, entre medias y al final de una cadena,
		 * dejando una sola cadena
		 *
		 * @param $string_one, cadena de caracteres que se desea limpiar.
		 * @return string cadena limpia.
		 */
		private function _getStringClean($string_one){
		
			if($string_one != ''){
				$string_one_clean = '';
				$string_one_clean = trim(str_replace(" ", "", $string_one));
				return $string_one_clean;
			}else 
				return '';
		}
		
		/***
		 * Select de type order procerr
		 * @return string
		 */
		private function _getSelect_orderProcessType(){
			$opt = ConfigurationCore::get("MXPS_ORDER_PROCESS_TYPE");
			
			$html_select = '<select class="form-control fixed-width-xxl " name="MXPS_ORDER_PROCESS_TYPE_SELECT" id="MXPS_ORDER_PROCESS_TYPE_SELECT">';
			$array_oder_type = array( "1" => "Estandar (5 pasos)", "2" => "Proceso de compra en una página", "3" => "Proceso OnePageCheckoutps (Mod. Externo)");
			
			for ($i=1; $i <= 3 ;$i++){
				if($opt == $i)
					$selected='selected="selected"';
				else	
					$selected='';
				
				$html_select .= '<option value="'.$i.'" '.$selected.'>'.$array_oder_type[$i].'</option>';
				
			}
			
				$html_select .='</select>';
				
			return $html_select;	
		} 
		
		/****************************************************************************/

		// Retrocompatibility 1.4/1.5
		private function initContext()
		{
			if (class_exists('Context'))
				$this->context = Context::getContext();
			else
			{
				//global $smarty, $cookie;
				$this->smarty;
				$this->cookie;
				$this->context = new StdClass();
				$this->context->smarty = $smarty;
				$this->context->cookie = $cookie;
			}
		}

	}//class

?>