<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    CorreosExpress/Departamento de integracion y desarrollo
 *  @copyright 2015-2016 Correos Express - Grupo Correos
 *  @license   LICENSE.txt
 *  @email peticiones@correosexpress.com
 */

include(dirname(__FILE__).'/../../config/config.inc.php');
Context::getContext()->shop->setContext(Shop::CONTEXT_ALL);
include(dirname(__FILE__).'/../../init.php');

//DELIVER CRON
if(Configuration::get('MXPS_ENABLEDELIVERCRON') == 1) {
	echo "Deliver cron enabled</br>";
	$status = Configuration::get('MXPS_DELIVERCRONSTATE1');
	$orders= Order::getOrderIdsByStatus($status);
	foreach ($orders as $o) {
		//get idship from idorder
		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedships WHERE id_order = '.$o.' ORDER BY id_ship DESC';
		try{
			if ($results = Db::getInstance()->ExecuteS($sql))
				foreach ($results as $row) {
				$idship = $row['numship'];
				if(getShipTracing($idship) == 12) { //ENTREGADO
					$history = new OrderHistory();
					$history->id_order = (int)$o;
					$history->changeIdOrderState((int)Configuration::get('MXPS_DELIVERCRONSTATE2'), $history->id_order);
					echo "Order: ".$o." status changed (deliver cron)</br>";
					$history->save();
				}
			}
		} catch(Exception $e){/*No se captura, solo se controla*/}
	}
} else echo "Deliver cron disabled</br>";

//SEND CRON
if(Configuration::get('MXPS_ENABLESENDCRON') == 1) {
	echo "Send cron enabled</br>";
	$status = Configuration::get('MXPS_SENDCRONSTATE1');
	$orders= Order::getOrderIdsByStatus($status);
	foreach ($orders as $o) {
		//get idship from idorder
		$sql = 'SELECT * FROM '._DB_PREFIX_.'savedships WHERE id_order = '.$o.' ORDER BY id_ship DESC';
		try{
			if ($results = Db::getInstance()->ExecuteS($sql))
				foreach ($results as $row) {
				$idship = $row['numship'];
				$result_state = getShipTracing($idship);
				if($result_state == 14 || $result_state == 15 || $result_state == 18 || ($result_state >= 2 && $result_state <= 11) || ($result_state >= 20 && $result_state <= 32)) { //ver xls estados para considerar ENVIADO
					$history = new OrderHistory();
					$history->id_order = (int)$o;
					$history->changeIdOrderState((int)Configuration::get('MXPS_SENDCRONSTATE2'), $history->id_order);
					echo "Order: ".$o." status changed (send cron)</br>";
					$history->save();
				}
			}
		} catch(Exception $e){/*No se captura, solo se controla*/}
	}
} else 	echo "Send cron disabled</br>";

echo "Cron correosexpress finished";

function getShipTracing($idship) {
	//echo $idship;

	//1. gen xml
	$soap_request = '
	<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:mes="messages.seguimientoEnvio.ws.chx.es">
	   <soapenv:Header/>
	   <soapenv:Body>
	      <mes:seguimientoEnvio>
		 <mes:solicitante>'.Configuration::get('MXPS_CODEDEMAND').'</mes:solicitante>
		 <mes:dato>'.$idship.'</mes:dato>
		 <!--Optional:-->
		 <mes:password></mes:password>
	      </mes:seguimientoEnvio>
	   </soapenv:Body>
	</soapenv:Envelope>';

// 1330008344051530

	//send xml to webservice
	$url = Configuration::get('MXPS_WSURLSEG');
	$header = array("Content-type: text/xml;charset=\"utf-8\"",
			    "Accept: text/xml",
			    "Cache-Control: no-cache",
			    "Pragma: no-cache",
			    "SOAPAction: \"".$url."\"",
			    "Content-length: ".Tools::strlen($soap_request),);

	$ch = curl_init();
	$options = array(CURLOPT_RETURNTRANSFER => true,
	CURLOPT_SSL_VERIFYHOST => false,
	CURLOPT_SSL_VERIFYPEER => false,
	CURLOPT_USERAGENT => 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
	CURLOPT_URL => $url ,
	CURLOPT_USERPWD => Configuration::get('MXPS_USER').":".Configuration::get('MXPS_PASSWD'),
	CURLOPT_POST => true ,
	CURLOPT_POSTFIELDS => $soap_request,
	CURLOPT_HTTPHEADER => $header,);

	curl_setopt_array($ch , $options);
	$output = curl_exec($ch);
	if(!$output) {
		echo 'Error durante la consulta del seguimiento del envio '. $idship .'registro de la recogida a ChronoExpress: '.curl_error($ch) . '" - Code: ' . curl_errno($ch);
		curl_close($ch);
		return 0;
	}
	else
	{
		//echo htmlentities($output);
		$dom = new DOMDocument();
		$dom->recover = TRUE;
		$dom->loadXML($output);
		$xml = $dom->getElementsByTagName("codEstado");
		$state = "";
		foreach ($xml as $element) {
			$state = $element->nodeValue;
			break;
		}
		curl_close($ch);
		echo "ID envio: " . $idship . " en estado: " .$state."</br>";
		return $state;

	}
}
?>