<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    CorreosExpress/Departamento de integracion y desarrollo
 *  @copyright 2015-2016 Correos Express - Grupo Correos
 *  @license   LICENSE.txt
 *  @email peticiones@correosexpress.com
 */

include(dirname(__FILE__).'/../../config/config.inc.php'); 
error_reporting(E_ERROR);
header('Access-Control-Allow-Origin: *');

$codigoP = Tools::getValue('cod_postal'); //$_POST['cod_postal'];
$pob     = Tools::getValue('poblacion');  //$_POST['poblacion'];

$listado_oficinas = _getListadoOficinasRestPre($codigoP,$pob);

/**
 * Devuelve un array con las oficinas de Correos segun el criterio utilizado.
 *
 * @param int $code_postal
 * @param string $poblacion
 * @return array Oficinas
 */
function _getListadoOficinasRestPre($code_postal,$poblacion){

	$data = array("cod_postal" => trim($code_postal), "poblacion" => trim($poblacion));
	$data_string = Tools::jsonEncode($data);
	$url= Configuration::get('MXPS_APIRESTOFI');
	
	//Cambiar Luego en Producción
	$user = Configuration::get('MXPS_USER');
	$pwd  = Configuration::get('MXPS_PASSWD');
		
	//API REST que recibe las oficinas de Correos
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$encodedAuth = base64_encode($user.":".$pwd);
	curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
			'Content-Type: application/json',
			'Content-Length: ' . strlen($data_string),
			'Authorization : Basic '.$encodedAuth	)
			);
	$result = curl_exec($ch);
	$status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);   //get status code
	$info = curl_getinfo($ch);
	curl_close($ch);
	echo $array_oficinas=$result;
}

?>